$title(MAC65/XL Cartridge  (c) 1988 ICD Inc)
$subtitle(Cartridge bank A for MAC65)
$include "equate.asm"
$include "tokens.asm"


	seg	banka
;==================================
;	line statement tables
;	---------------------
statement:
	db	eol | $80
	x_db	'.IF'
	x_db	'.ELSE'
	x_db	'.ENDIF'
	x_db	'.MACRO'
	x_db	'.ENDM'
	x_db	'.TITLE'
	x_db	' '
	x_db	'.PAGE'
	x_db	'.WORD'
	x_db	'.ERROR'
	x_db	'.BYTE'
	x_db	'.SBYTE'
	x_db	'.DBYTE'
	x_db	'.END'
	x_db	'.OPT'
	x_db	'.TAB'
	x_db	'.INCLUDE'
	x_db	'.DS'
	x_db	'.ORG'
	x_db	'.EQU'

; 65C02 instructions

	x_db	'BRA'		; branch always
	x_db	'TRB'
	x_db	'TSB'
	x_db	'.FLOAT'
	x_db	'.CBYTE'
	x_db	';'
	x_db	'.LOCAL'
	x_db	'.SET'
	x_db	'*='
	x_db	'='
	x_db	'.='


;	This table is global because DDT needs it!
;	------------------------------------------
mnetab:	x_db 'JSR','JMP','DEC','INC'
	x_db 'LDX','LDY','STX','STY','CPX','CPY','BIT'
	x_db 'BRK','CLC','CLD','CLI','CLV','DEX','DEY'
	x_db 'INX','INY','NOP','PHA','PHP','PLA','PLP'
	x_db 'RTI','RTS','SEC','SED','SEI','TAX','TAY'
	x_db 'TSX','TXA','TXS','TYA','BCC','BCS','BEQ'
	x_db 'BMI','BNE','BPL','BVC','BVS'
	x_db 'ORA','AND','EOR','ADC','STA','LDA','CMP'
	x_db 'SBC','ASL','ROL','LSR','ROR'
	db $80		; comment

	x_db 'STZ'
	x_db 'DEA','INA'
	x_db 'PHX','PHY'
	x_db 'PLX','PLY'
	db 0


;============================
;	function table
;============================
; order in table is relevent!

function:
	x_db	"'"	; ascii literal
	x_db	'%$'	; macro string
	x_db	'%'	; macro parameter
	x_db	'*'	; current asm pc
	x_db	' ',' '
	x_db	'a'
	x_db	'q'
	x_db	'+'	; addition
	x_db	'-'	; subtraction
	x_db	'*'	; mutliplication
	x_db	'/'	; division
	x_db	'&'	; logical and
	x_db	'.DEF'	; unary lab def
	x_db	'='	; comparison
	x_db	'<='	; less or equal
	x_db	'>='	; greater or equal
	x_db	'<>'	; not equal
	x_db	'>'	; less than
	x_db	'<'	; greater than and
	x_db	'-'	; unary minus
	x_db	'['	; oper left para
	x_db	']'	; oper right para
	x_db	'.OR'	; basic-like or
	x_db	'.AND'	; basic-like and
	x_db	'.NOT'	; basic-like not
	x_db	'!'	; logical or
	x_db	'^'	; logical eor
	x_db	'.REF'	; label reference
	x_db	'\'	; modulo

	db	$80,$80,$80,$80	; filler

; inbedded tables (save 3 bytes)
; ------------------------------
edit:	x_db	'Edit'
wh	x_db	'What!'
txtmd:	x_db	'Text:'

	x_db	'.REF '		; label ref list
	x_db	'.DEF '		; define list
	x_db	'.NOT '		; not list
	x_db	' .AND '	; and list
	x_db	' .OR '		; or list
	x_db	' <'		; low byte
	x_db	' >'		; high byte

; begin terimators
; ----------------
	x_db	',X)'		; indirect ,x
	x_db	'),Y'		; indirect ,y
	x_db	',Y'		; indexed ,y
	x_db	',X'		; indexed ,x
	x_db	')'		; indirect abs
	x_db	','		; comma syntax
	db	eol | $80	; end of line
	x_db	','		; comma list
	x_db	'#'		; imm/dev follows
	x_db	'A'		; accumulator adressing
	x_db	'('		; left para
	x_db	'"'		; text string
	x_db	'$'		; hex follows
	x_db	'Q'		; rep querry
	x_db	'NO'		; option off
	x_db	'NO '		; list no
	x_db	'OBJ'		; object
	x_db	'ERR'		; error
	x_db	'EJECT'		; page eject
	x_db	'LIST'		; asm listing
	x_db	'XREF'		; x-ref
	x_db	'MLIST'		; macro list
	x_db	'CLIST'		; conditional l.
	x_db	'NUM'		; assembler auto-num
	x_db	'M'		; merge
	db	0	; end of table


;	statement syntax adress table
;	-----------------------------
linetab	equ	$-2
	dw	ify-1		; if
	dw	elsey-1		; else
	dw	elsey-1		; endif
	dw	macroy-1	; macro define
	dw	elsey-1		; endm
	dw	pagey-1		; title
	dw	macroxy-1	; macro exec
	dw	pagey-1		; page
	dw	wordy-1		; word
	dw	pagey-1		; error
	dw	bytey-1		; byte
	dw	bytey-1		; sbyte
	dw	wordy-1		; dbyte
	dw	endly-1		; end
	dw	opty-1		; opt
	dw	taby-1		; tab
	dw	includy-1	; include
	dw	equy-1		; ds
	dw	equy-1		; org
	dw	equy0-1		; equ
	dw	equy-1		; bra
	dw	equy-1,equy-1   ; trb & tsb
	dw	floaty-1	; float
	dw	bytey-1		; cbyte
	dw	endly-1		; comment
	dw	endly-1		; local
	dw	sety-1		; system set
	dw	equy-1		; origin
	dw	equy0-1		; equate
	dw	equy0-1		; set equate
         	
	dw	jsry-1		; jsr instr
	dw	jmpy-1		; jmp instr
	dw	incy-1		; dec instr
	dw	incy-1		; inc instr
	dw	ldxy-1		; ldx instr
	dw	ldyy-1		; ldy instr
	dw	stxy-1		; stx instr
	dw	incy-1		; sty instr
	dw	cpxy-1		; cpx instr
	dw	cpxy-1		; cpy instr
	dw	bity-1		; bit instr
	dw	brky-1		; type implied
	dw	bccy-1		; type branch
	dw	oray-1		; type multi
	dw	asly-1		; type accumulator



;	command statement table
;	and syntax table adress
;	-----------------------
command:
	dw	eoly-1		; bye
	 x_db	'BYE'
	dw	listy-1		; list
	 x_db	'LIST'
	dw	eoly-1		; new
	 x_db	'NEW'
	dw	dely-1		; del
	 x_db	'DEL'
	dw	findy-1		; find
	 x_db	'FIND'
	dw	asmy-1		; asm
	 x_db	'ASM'
	dw	includy-1	; save
	 x_db	'SAVE'
	dw	entery-1	; load
	 x_db	'LOAD'
	dw	entery-1	; enter
	 x_db	'ENTER'
	dw	includy-1	; bload
	 x_db	'BLOAD'
	dw	bsavey-1	; bsave
	 x_db	'BSAVE'
	dw	numy-1		; num
	 x_db	'NUM'
	dw	listy-1		; print
	 x_db	'PRINT'
	dw	numy-1		; ren
	 x_db	'REN'
	dw	repy-1		; rep
	 x_db	'REP'
	dw	eoly-1		; size
	 x_db	'SIZE'
	dw	lomemy-1	; lomem
	 x_db	'LOMEM'
	dw	eoly-1		; cp
	 x_db	'CP'
	dw	eoly-1		; dos
	 x_db	'DOS'

	$if 0
	 dw	dy-1	; d - display
	  x_db	'D'
	 dw	cy-1	; c - change
	  x_db	'C'
	$endif

	dw	qy-1		; convert
	 x_db	'?'
	dw	eoly-1		; text command
	 x_db	'TEXT'
	dw	eoly-1		; enter DDT
	 x_db	'DDT'
	db 0,0,0


;	editor routine table
;	--------------------
extabl	dw	ataribye-1	; bye
	dw	listx-1		; list
	dw	newx-1		; new
	dw	delx-1		; del
	dw	findx-1		; find
	dw	asmx-1		; asm
	dw	savex-1		; save
	dw	loadx-1		; load
	dw	enterx-1	; enter
	dw	bloadx-1	; bload
	dw	bsavex-1	; bsave
	dw	numx-1		; num
	dw	printx-1	; print
	dw	renx-1		; ren
	dw	repx-1		; rep
	dw	sizex-1		; size
	dw	lomemx-1	; lomem
	dw	dos-1		; cp
	dw	dos-1		; dos

	$if 0
	 dw	dx-1	; display
	 dw	cx-1	; change
	$endif

	dw	qx-1		; convert
	dw	textx-1		; text mode
	dw	ddt-1		; dunion's ddt



;	Delete line
;	-----------
dell:	proc
	jsr	fndli		; find line
	bcs	os		; br if not there
	jsr	getoset		; move size
	pha	
	jsr	adoff		; set from adr
	pla	
	jsr	contxt		; go contract
	lda	#$40		; show rep that
	sta	rpif		; line was deleted
os	jmp	oy		; unc, test rep
	endproc


;	print 'what'
;	------------
_what:	proc
	lda	#$35		; sound effect
	ldx	#$ac
	jsr	sd
	ldx	#low wh
	ldy	#high wh
	jsr	ptse
	jmp	prmpt		; go re-prompt
	endproc


;	sound!
;	------
sd1:	proc
	txa			; sound off x=0
sd	sta	pokey		; channel 1
	stx	pokey+1
	rts	
	endproc


;	execute editor command
;	----------------------
exec:	proc
	asl	a
	tay			; get index to table
	lda	extabl+1,y	; get adr
	pha			; and stack
	lda	extabl,y
	pha	
	lda	cox		; save for rep
	sta	cmdlg
	ldy	#0		; reset out-put
	sty	cox		; index
	rts			; go to it
	endproc


;	editor text mode
;	----------------
textx	proc
	lda	#$ff
	jmp	newtxt
	endproc


;	execute	syntax
;	--------------
stc:	proc
	lda	saxpc+1		; init to
	sta	spc+1		; first level
	lda	saxpc
	sta	spc
	lda	cox
	sta	sox
	lda	cix
	sta	six
	ldy	#0		; clr:
	sty	curtoke		; current token
	sty	condptr		; cond text index
	sty	actptr		; current text index
	sty	stklvl		; set at first level

sloop	jsr	getop
	bmi	sbra		; syntax branch
	cmp	#1		; absolute?
	bcc	sabs		; yes, abs internal
	bne	cksng		; go check

	jsr	sabs		; go abs external
	bcc	sloop		; sucessful test
	jmp	sterm		; look for term

cksng	cmp	#5
	bcc	sret		; go ret
	beq	pop		; go pop stack

	jsr	stest		; go test
	bcc	sloop		; sucessful test
	jmp	sterm		; look for term

pop	lda	stklvl		; don't pop below
	beq	sloop		; first level
	sbc	#4		; cs, next lower level
	tax	
	lda	sox+4,x		; copy input &
	sta	sox,x		; output indices to
	lda	six+4,x		; this level
	sta	six,x
	stx	stklvl
	jmp	sloop		; and get nxt

sbra	sec			; compute new
	ldx	#0		; table addr
	sbc	#@+1
	bcs	bck		; a back branch
	 dex	
bck	clc	
	adc	saxpc		; form new pc addr
	pha			; save
	txa	
	adc	saxpc+1
	pha			; save
	jmp	spush		; stack current

sabs	jsr	getop		; get adress
	pha	
	jsr	getop
	pha	
	bcc	spush		; br if internal
	 rts			; go absolute

v0	lda	#15
	jmp	fter		; fatal err fix

spush	ldx	stklvl		; inc stack pointer
	inx	
	inx	
	inx	
	inx	
	bmi	v0		; stack overflow!
	stx	stklvl
	lda	cix		; save current ptrs
	sta	six,x
	lda	cox
	sta	sox,x
	lda	saxpc
	sta	spc,x
	 lda	saxpc+1
	 sta	spc+1,x
	pla			; restore new addr
	sta	saxpc+1
	pla	
	sta	saxpc
	jmp	sloop		; continue...

sret	ldx	stklvl		; at first level?
	bne	sret1		; no, else
	rts			; syntax all done!

sret1	lda	spc,x		; restore old
	sta	saxpc		; table adress
	lda	spc+1,x
	sta	saxpc+1
	dex			; pop stk ptr
	dex	
	dex	
	dex	
	stx	stklvl		; save it
	bcs	sterm		; br if bad
	 jmp	sloop		; else, continue


sterm	jsr	getop
	bmi	sterm		; skip branch
	cmp	#2		; abs reference?
	beq	v1		; go 'or'
	bcs	stwo
	jsr	incpt		; skip absolute
	jsr	incpt		; adress
	bne	sterm		; unc

stwo	cmp	#3		; return?
	beq	sret		; yup
	cmp	#4+1		; an 'or-return'?
	bcs	sterm		; no, keep skipping

	jsr	restr		; restore last valid
	clc			; set sucess
	jmp	sret		; and go return

v1	jsr	restr
	jmp	sloop		; continue...
	endproc



;	routines getop & incpt
;	----------------------
getop	proc
	jsr	incpt		; bump syntax pc
	ldx	#0
	lda	(saxpc,x)	; get code
	rts	

incpt	inc	saxpc
	bne	..2
	 inc	saxpc+1
..2	rts	
	endproc


restr	proc
	ldy	cix
	jsr	valid		; set valid text
	ldx	stklvl		; restore indices
	lda	six,x
	sta	cix
	lda	sox,x
	sta	cox
	rts	
	endproc


;	syntax externals
;	----------------
; test for external assembly test,
;  or internal token match

;	6 = test for eol/comment
; 		note: 6 is strict comment
;		6,6 is loose comment
;	7 = test for hex #
;	8 = test for dec #
;	9 = special change token

stest	proc
	cmp	#ch+1		; internal tst?
	bcs	tsttok		; yup

	tay			; get table indx
	lda	..exh-6,y	; get routine
	pha	
	lda	..exl-6,y
	pha	
	rts			; and go to it!

; external assembly test table
; ----------------------------
..exl	db	low s@@end-1, low s@@hex-1
	db	low s@@dec-1, low s@@ch-1

..exh	db	high (s@@end-1), high (s@@hex-1)
	db	high (s@@dec-1), high (s@@ch-1)

; change token
; ------------
s@ch	dec	cox		; change level before
s@@ch	jsr	getop		; get change token
	dec	cox		; pop output indx
	clc			; set sucess

ptoke	ldy	cox		; put in buff
	sta	(exbuf),y
	inc	cox
	beq	..tob		; overflow!
	 rts	
..tob	lda	#8		; buff ovrflo
	jmp	fter		; fatal err fix
	endproc


;	test for internal token match
;	-----------------------------
tsttok	proc
	jsr	skpspace
	cpy	actptr
	beq	nsearch		; don't search
	sty	actptr		; actual text
	lda	#high function
	ldy	#low function
	ldx	#0
	jsr	search
	bcs	notfnd		; not there

	stx	condptr		; text conditional
	lda	svf2		; table indx
	adc	#ch+1		; first function
	sta	curtoke

nsearch	ldy	#0		; comp this token
	lda	(saxpc),y
	cmp	curtoke
	beq	match		; match
	sec			; else, set fail
	rts	

match	ldx	condptr
	stx	cix
	jsr	ptoke
	clc	
	rts	

notfnd	lda	#0		; set null token
	sta	curtoke
	rts	
	endproc


;	search for statement
;	--------------------
ssrch	proc
	jsr	skpspace	; table search
	ldx	#0
	lda	#high statement
	ldy	#low statement
	jsr	search
	stx	cix
	lda	svf2
	rts	
	endproc


search:	proc
	stx	skipfc		; skip factor
	ldx	#-1		; set -1 entry
	stx	svf2		; x
	sta	srcadr+1	; adress table high

nx99	sty	srcadr		; adress table low
	inc	svf2		; inc entry
	ldx	cix		; pointer in buffer
	ldy	skipfc		; skip
	lda	(srcadr),y	; end of tab?
	beq	u0		; yup

v8	lda	lbuff,x		; get buff char
	and	#$7f		; seven bits
	eor	(srcadr),y	; compare
	asl	a		; save end stat
	beq	v7		; br if match,
	bcs	v9		; if symbol end

nx00	iny			; fail, look for
	lda	(srcadr),y	; symbol end
	bpl	nx00

v9	sec			; y=y+1
	tya			; pnt to nxt symb
	adc	srcadr
	tay			; y=low
	bcc	nx99		; save time!
	inc	srcadr+1	; if necessary
	bne	nx99		; unc

v7	iny			; set for nxt
	inx			; compare
	bcc	v8		; if not end
	clc			; else, sucess
	rts	

u0	sec			; fail
	rts	
	endproc


;	external routine dec num test
;	-----------------------------
s@@dec	proc
	jsr	skpspace	; skip spaces
decasy	sty	svn2		; save current text indx
	jsr	afp		; to floatint pt
	bcs	badnum		; br if bad
	jsr	fpi		; cvrt to intger
	bcc	..ok		; go save token

badnum	ldy	svn2		; bad #, restore text
	sty	cix		; carry was set
	jmp	valid		; go do valid pointer

			; external hex or dec num test
hxdc	jsr	skpspace	; hex or dec #
	lda	(inbuff),y	; get character
	cmp	#'$'		; dollar sign?
	bne	decasy		; no, try dec num
	inc	cix		; skip '$'
	bne	s@@hex		; unc to tst hex

..ok	lda	#tdb		; set as byte
hexent	ldx	fr0+1		; is it byte?
	bne	..ok0		; no, do word
	jsr	ptoke		; save num type
	lda	fr0		; and save num
	jmp	..h0		; go

..ok0	sec	
	sbc	#1		; set as word
	jsr	ptoke		; num type
ok9	lda	fr0		; save num
	jsr	ptoke
	lda	fr0+1
..h0	jsr	ptoke
	clc			; sucess
	rts	
	endproc


;	external test hex num
;	---------------------
s@@hex	proc
	jsr	skpspace
	sty	svn2		; save inbuff index
	lda	#0		; clr result
	sta	ztemp4
	sta	ztemp4+1
	jsr	getnib		; first must
	bcs	badnum		; be valid
..ar	clc			; add in result
	adc	ztemp4+1
	sta	ztemp4+1
	bcc	..v6
	inc	ztemp4
..v6	jsr	getnib		; get next
	bcs	..as		; done!

	ldx	#4		; shift into position
..sh	$if atari
	 jsr	ilshift
	$else
	 asl	ztemp4+1
	 rol	ztemp4
	$endif
	bcs	badnum		; oops- bad num
	dex	
	bne	..sh
	beq	..ar		; unc get nxt

..as	lda	ztemp4		; move result
	sta	fr0+1
	lda	ztemp4+1	; (sic)
	sta	fr0
	dec	cix		; point back
	lda	#thb		; set hex byte
	jmp	hexent		; go process
	endproc


getnib	proc
	ldy	cix		; get hex nibble
	inc	cix
	lda	(inbuff),y
	sec	
	sbc	#'0'
	bmi	..x9
	cmp	#$0a
	bcc	..x8
	sbc	#7
	cmp	#$0A
	bcc	..x9
	cmp	#$10
	bcc	..x8
..x9	sec	
..x8	rts	
	endproc



;	external test for string
;	to delimiter as follows:
;	------------------------
; ffnd - finds same as first
; fsav - end in <
; fspc - end in ,
; frep - end same as ffnd
; fstr - end in '
;
ffnd	proc
	lda	#$00		; no null length & get from tpobuf
	sta	temp
	jsr	skpspace
	lda	(inbuff),y	; get char
	cmp	#eol		; eol?
	beq	bad6		; illegal!
	bne	fv1		; look for same

fsav	lda	#'<'		; get test char
	bne	fv4		; unc

fspc	jsr	skpspace
	lda	#','
fv4	ldy	#0		; no null
	sty	temp		; x
	jsr	fv0		; go find it
	bcs	cllen		; go put str len
qq	dec	cix		; point back to ,
	rts	

frep	dec	cix		; point to last
	lda	#$c0		; set for ''
	ldx	#'"'		; was delimiter ''?
	cpx	svf2
	beq	..fep		; yes, get from tpobuf
	 lda	#$40
..fep	sta	temp		; allow null
	jmp	fv2

fstr	lda	#0		; dis-allow null
	sta	temp		; x
	lda	#'"'		; double quotes
	jsr	fv0		; find them
	bcc	qq		; sucess
	rts	
	endproc



fv0	proc
	dec	cix		; back up 1 before
fv1	sta	svf2		; save delimiter
fv2	tax			; save
	lda	cox		; save output indx
	sta	svn2		; x
	inc	cox		; dummy for len
fv3	inc	cix		; get char
	ldy	cix

	bit	temp		; where to get chars from
	bpl	ginb
	lda	tpobuf,y	; rep only
	bne	ginc		; unc, unless 'cntrl-,'

ginb	lda	(inbuff),y
ginc	cmp	#eol		; eol?
	beq	bad6		; yup, error
	cmp	svf2		; delimiter?
	beq	fv5		; yup, compute len
	jsr	ptoke		; save str char
	bne	fv3		; unc

fv5	inc	cix		; index to nxt
cllen	clc			; get str len
	lda	cox
	sbc	svn2
	bne	fv6		; non-zero
	bit	temp		; allow zero?
	bvc	..cf		; no, error
fv6	ldy	svn2		; indx len in out
	ora	#$80		; high bit on
	sta	(exbuf),y	; str len +128
	clc			; sucess
	rts	
bad6	sec			; fail
	rts	

			; external tst for ascii char after single quote
tstasc	ldy	cix		; buff indx
	lda	(inbuff),y	; get char
	cmp	#eol		; if eol, error
	beq	..cf
..ts2	jsr	ptoke		; else, save it
	inc	cix		; point to nxt
..ts1	clc			; sucess
	rts	

			; external for mandatory label
miss	ldy	#3		; byte should
	lda	(exbuf),y	; be minus
	bmi	..ts1		; if label is
	bpl	..cf		; present

			; external for mandatory no label
miss0	jsr	miss		; call tst lab &
	bcs	..ts1		; reverse stat
..cf	sec	
	rts	


;	external test for single unary
;	------------------------------
only1
	ldy	cox
	dey			; get last token
	lda	(exbuf),y	; can be used
	cmp	#@defl		; only once in an
	beq	..j		; expression
	cmp	#@low
	beq	..j
	cmp	#@high
	beq	..j
	clc	
..j	rts	


;	test for asm comma
;	------------------
tcoma
	jsr	skpspace
	sty	saxtx
	lda	(inbuff),y
	cmp	#','
	bne	..cf		; err
	lda	#@cma		; put in buffer
	bne	..ts2		; unc
	endproc


illegal	db	' ,[]+-*/\!&^"'

s@@end	proc
	ldx	#12		; set strict count
	ldy	#1		; test for loose
	lda	(saxpc),y
	cmp	#6
	bne	..k1		; do strict comment

	jsr	incpt		; loose comment type
	ldx	#0
..k1	jsr	skpspace
	lda	(inbuff),y
..k2	cmp	illegal,x
	beq	valid		; no good
	dex	
	bpl	..k2		; again or legal
yup	cmp	#eol		; eol?
	bne	comment		; no, do comment
	inc	cox		; dummy bump
	clc			; sucess!

			; up-date valid text pointer
valid	php			; save status
	cpy	saxtx		; update valid text
	bcc	yop
	 sty	saxtx
yop	plp			; get status
	rts	
	endproc



;	syntax source line
;	------------------
synli:	proc
	jsr	konvert		; do lower case
	ldy	cix
	sty	svn2
	sty	saxtx		; set valid text
	lda	(inbuff),y
	cmp	#$20		; manadatory!
	beq	good		; so far...

error	lda	#3		; oops
	sta	cox		; reset output buf
	ldy	saxtx		; show where
	lda	(inbuff),y	; syntax failed
	cmp	#eol		; failed at end?
	bne	feol		; no
	iny			; bump eol 1
	sta	tpobuf,y
	dey	
	lda	#$20		; space
feol	eor	#$80		; flag it
	sta	tpobuf,y	; save it
	lda	#0		; err line token
	beq	..mc		; unc

comms	lda	#@scomment	; statement
	bne	..mc		; comment
comment	lda	#@comment
..mc	jsr	ptoke
..mc0	ldy	cix		; move string
	lda	tpobuf,y	; to exec buff
	jsr	ptoke
	inc	cix
	cmp	#eol		; done?
	bne	..mc0
	clc			; set sucessful
..ble	rts	

			; check label/statement/comment
good	inc	cix		; get nxt char
	inc	saxtx		; valid text ptr
	ldy	cix
	lda	(inbuff),y
	cmp	#';'		; semi-colon
	beq	comms
	cmp	#'*'		; or asterisk ok
	beq	comms		; for comment
	bit	txtflag		; in text mode?
	bmi	comms		; yup, do comment

	tax			; save a
	tya			; save cix for
	pha			; possible error

	lda	#high (nlabel-1)	; set for no label
	ldy	#low (nlabel-1)
	cpx	#$20
	beq	..nola
	 dey			; YA = (label-1)

..nola	sta	saxpc+1
	sty	saxpc
	jsr	stc		; do syntax
	pla	
	bcc	..ble		; go rts
	sta	cix		; reset inbuff pointer
	jmp	error
	endproc


;	fnd func. & synt
;	----------------
funt	proc
	jsr	skpspace
	sty	svn2
	sty	saxtx		; set valid ptr

	jsr	ssrch		; srch statements

	bcc	fnt
	lda	#@macrox	; asume macro call

fnt	jsr	ptoke		; save statement
	cmp	#@seol		; for label eol
	beq	ysgd

			; divide syntax by instr type
	cmp	#@brk		; a single instruction type?
	bcc	fun1		; yup
	ldx	#@brk		; pre-set indx
..yl	cmp	..itp-@brk,x	; find type
	bcc	fun0		; yup
	inx			; bump x
	cpx	#@brk+3		; done?
	bcc	..yl		; no

	cmp	#@rockwell	; new instr?
	bcc	fun0		; nope
	bne	fun2
				; the stz instr
	ldx	#@bit		; same syntax
	 db $2c
fun2	ldx	#@brk		; get implied type

fun0	txa	
fun1	asl	a		; double for table index
	tay			; to y
	lda	linetab,y	; get syntax routine
	sta	saxpc		; adress
	lda	linetab+1,y
	sta	saxpc+1
	pla			; pop old return
	pla	
	jsr	stc		; do syntax
	bcs	nogd		; bad!

ysgd	clc			; sucess
nogd	rts	

..itp	db	@bcc,@ora,@asl
	endproc



;	label text routines (tstlabi for prefix labels)
;	-----------------------------------------------
tstlab	proc
	jsr	skpspace	; skip spaces
tstlabi	ldy	cix
	sty	svn2		; save inbuff
	sty	svf2

	lda	(inbuff),y	; first character
	jsr	tstletter	; must be alpha
	bcs	nolab		; it isn't...

loop1	ldy	cix		; get inbuff index
	inc	cix		; bump pointer
	lda	(inbuff),y	; get character
	jsr	tstletter	; is it letter?
	bcc	loop1		; yup, do next
	jsr	tstnum		; no, number type?
	bcc	loop1		; yup, get next
	lda	cox		; save cox for macro
	tax	
	dec	cix		; pop input indx
	lda	cix		; form lab len
	sbc	svn2		; cs
	ora	#$80		; flag label-type
	jsr	ptoke		; store in outbuf

loop2	ldy	svn2		; move to outbuf
	inc	svn2
	cpy	cix		; done?
	bcs	cka		; yes, test for 'a'
	lda	(inbuff),y	; move character
	jsr	ptoke
	bne	loop2		; unc

cka	txa			; test for label 'a'
	tay	
	lda	(exbuf),y	; check length
	cmp	#$81		; one?
	bne	done		; no, go sucess
	iny	
	lda	(exbuf),y	; check character
	cmp	#'A'		; a?
	bne	done		; no, sucess

	stx	cox		; reset exbuf index
nolab	lda	svf2		; reset inbuf index
	sta	cix		; carry was set
	rts	
	endproc



;	test letter & number
;	--------------------
tstletter proc
	cmp	#':'		; colon
	beq	done
	cmp	#'_'		; underline
	beq	done
	cmp	#'?'
	bcc	nochar
	cmp	#'['
	rts	
done	clc			; sucess
	rts	

..tst	cmp	#'.'
	beq	done
nochar	sec	
	rts	
			; test macro name label
tstlab0	jsr	tstlab		; ck label
	bcs	nochar		; bad
	txa			; x= cox at label
	tay	
	lda	(exbuf),y	; get lab size
	adc	#1		; bump by 1 cc
	sta	(exbuf),y	; store
	lda	#$20		; trailing space
	jmp	ptoke		; and ret

tstnum	cmp	#'0'		; test decimal
	bcc	..tst		; number
	 cmp	#'9'+1
	rts	
	endproc



konvert: proc
	ldy	#$7f
sasis	lda	(inbuff),y
	sta	tpobuf,y
	dey	
	bpl	sasis

	lda	epf		; skip if rep mode
	cmp	#rmode
	beq	konv
			; change lower to upper
nextup	iny	
	lda	(inbuff),y	; get char
	cmp	#eol		; done?
	beq	konv
	and	#$7f		; normalize

	cmp	#'"'		; double quote?
	bne	trylow
	sta	(inbuff),y	; save quote
tryq	iny	
	lda	(inbuff),y
	cmp	#eol		; eol?
	beq	konv
	and	#$7f		; search for
	cmp	#'"'		; other '
	bne	tryq

trylow	cmp	#'a'		; test lower
	bcc	putbck
	cmp	#'z'+1
	bcs	putbck
	 adc	#-$20		; subtract $20

putbck	cmp	#tab		; tab?
	bne	khar		; nope
	lda	#$20		; rep with space
	sta	tpobuf,y	; echo in back-up

khar	sta	(inbuff),y
	cmp	#'''		; single quote?
	bne	nextup		; no
	iny	
	lda	(inbuff),y	; next an eol?
	cmp	#eol
	bne	nextup		; no
konv	rts	
	endproc



;	execute syntax & table search syntax macros
;	-------------------------------------------

nully	db	1, high (bad6-1), low (bad6-1)	; always return an error

; .float
; ------
floaty	db	1, high (fspc-1), low (fspc-1)	; first # string
	db	$C0 + (fop0-$), 6, 3

fop0	db	@lcma, ch, @cma
	db	1, high (fspc-1), low (fspc-1)
	db	$C0 + (fop0-$), 4

; .tab & .set
; -----------
taby	db	0, low (sx-1), high (sx-1)
	db	1, high (tcoma-1), low (tcoma-1)

sety	db	0, low (sx-1), high (sx-1)
	db	1, high (tcoma-1), low (tcoma-1)
	db	$C0 + (equy-$), 3

; =, .=, *=
; ---------
equy0	db	1, high (miss-1), low (miss-1)	; = & .= have label
equy	db	0, low (sx-1), high (sx-1)	; expression
endy	db	6,3				; implied

; macro defination
; ----------------
macroy	db	1, high (miss0-1), low (miss0-1)	; no label!
	db	1, high (tstlab0-1), low (tstlab0-1)	; macro name
endly	db	6,6,3					; loose comment

; .else & .endif & .endm
; ----------------------
elsey	db	1, high (miss0-1), low (miss0-1)	; no label!
	db	$C0 + (endly-$), 3

; .if
; ---
sre	db	$C0 + (srf-$), @ref, ch, @refl
	db	1, high (tstlab-1), low (tstlab-1)	; label reference
	db	3

srf	db	@not, ch, @notl
	db	4

ify	db	0, low (sx-1), high (sx-1)		; expr
	db	$C0 + (endly-$), 3

; .opt
; ----
opty	db	$C0 + (j1-$)
	db	$C0 + (endy-$), 3

j1	db	$C0 + (j2-$)
	db	$C0 + (j3-$)
	db	$C0 + (j4-$), 3

j2	db	@lno, ch, @no
	db	4

j3	db	@obj, 2, @err, 2, @wait, 2
	db	@eject, 2, @list, 2, @num, 2
	db	@mlist, 2, @clist, 3

j4	db	1, high (tcoma-1), low (tcoma-1)
	db	$C0 + (j1-$), 4

; test byte modifier
; ------------------
modf	db	@plus				; plus
	db	0, low (sx-1), high (sx-1)	; expression
	db	1, high (tcoma-1), low (tcoma-1)
	db	4

; macro execution
; ---------------
macroxy	db	1, high (tstlab0-1), low (tstlab0-1)	; macro name
	db	$C0 + (svr1-$), 6, 3

svr1	db	0, low (svr-1), high (svr-1)	; exp or string
	db	$C0 + (byt1-$), 4		; byte syntax

; .page & .title
; --------------
pagey	db	@qu
	db	1, high (fstr-1), low (fstr-1)
	db	@qu, 6, 2, 6, 3

; db & .sbyte
; -----------
bytey	db	$C0 + (modf-$)
	db	$C0 + (svr-$)
	db	$C0 + (byt1-$), 6, 3

byt0	db	5					; pop syntax
byt1	db	1, high (tcoma-1), low (tcoma-1)
	db	$C0 + (svr-$)
	db	$C0 + (byt0-$), 4

; dw & .dbyte
; -----------
wordy	db	$C0 + (sx-$)
	db	$C0 + (wor1-$), 6, 3
wor0	db	5					; pop syntax
wor1	db	1, high (tcoma-1), low (tcoma-1)
	db	$C0 + (sx-$)
	db	$C0 + (wor0-$), 4

; string or expression
; --------------------
svr	db	$C0 + (sx-$), 2, @qu			; expression
	db	1, high (fstr-1), low (fstr-1)		; quoted string
	db	@qu, 2, @mstr
	db	0, low (bsx5-1), high (bsx5-1)		; macro string
	db	3


;	syntax instructions
;	-------------------
jmpy	db	@lp
	db	$C0 + (sx-$)
	db	0, low (gp9-1), high (gp9-1)
	db	$C0 + (brky-$), 2

jsry	db	$C0 + (sx-$), 6, 3
cpxy	db	$C0 + (@pndt-$)
bccy	db	$C0 + (sx-$), 6, 3
brky	db	6, 6, 3

;	syntax expression
;	-----------------
sx	db	0, low (sre-1), high (sre-1)		; ref label
	db	2
	db	0, low (bsx-1), high (bsx-1)		; expr
	db	3

@pndt	db	@pnd, 4				; test for '#'

gp0	db	@lp
	db	$C0 + (sx-$)
	db	$C0 + (gp1-$), 2

gp2	db	@pnd
	db	$C0 + (sx-$), 2

gp3	db	$C0 + (sx-$)
	db	$C0 + (gcmax-$), 3

gp5	db	@pnd
	db	$C0 + (sx-$), 2

gp6	db	$C0 + (sx-$), @cmay, 2
	db	$C0 + (sx-$), 3

bity						; new addr modes
incy	db	$C0 + (gp3-$), 6, 3
ldyy	db	$C0 + (gp2-$), 6, 3
asly	db	$C0 + (gp3-$), 6, 2
	db	@a, 6, 3

oray	db	$C0 + (sx-$), @cmay, 6, 2
	db	$C0 + (gp0-$), 6, 3
ldxy	db	$C0 + (gp5-$), 6, 3
stxy	db	$C0 + (gp6-$), 6, 3

gp1	db	@pcmay, 2
gp9	db	@pcmax, 2, @rp, 3
gcmax	db	@cmax, 4


;	syntax editor commands
;	----------------------
tsq	db	@q,2,s.q,ch,@q,3
tsa	db	@a,2,s.a,ch,@a,3

dely	db	8
	db	$C0 + (a03-$), @eol, 3

a03	db	@lcma, 8, 4	; dec num

findy	db	0, low (a11-1), high (a11-1)		; filespec
	db	1, high (ffnd-1), low (ffnd-1)		; string
	db	$C0 + (a02-$)				; line numbers
	db	$C0 + (a01-$)				; options

eoly	db	@eol, 3			; eol
repy	db	1, high (ffnd-1), low (ffnd-1)
	db	1, high (frep-1), low (frep-1)
	db	$C0 + (a02-$)
	db	$C0 + (a00-$), @eol, 3

a00	db	@lcma
	db	$C0 + (tsq-$), 2

a01	db	@lcma
	db	$C0 + (tsa-$), 4

asmy	db	$C0 + (a05-$), 2		; (source)! or
	db	$C0 + (a04-$)			; (source or ,)
	db	$C0 + (le-$), 2			; (list)! or
	db	$C0 + (a04-$)			; (source or ,)
	db	$C0 + (l4-$)			; (list or ,)
	db	$C0 + (a05-$), 2		; (object)! or

	db	$C0 + (a04-$)			; (source or,)
	db	$C0 + (l4-$)			; (list or ,)
	db	$C0 + (a04-$)			; (object or ,)
	db	$C0 + (a05-$), 2, @eol, 3	; (xref)! or !

a02	db	8
	db	$C0 + (a03-$), 4
l4	db	$C0 + (ll-$), @lcma, 2
	db	$C0 + (a04-$), 3
le	db	$C0 + (ll-$), @eol, 2
	db	$C0 + (a05-$), 3

ll	db	@pnd, @minus			; rep @pnd
	db	1, high (s@ch-1), low (s@ch-1)	; with @minus
	db	@minus, 3

a04	db	$C0 + (bloady-$), @lcma, 2
	db	@lcma, 3

a05	db	$C0 + (bloady-$), @eol, 3
a11	db	$C0 + (bloady-$), @lcma, 4
a13	db	8, @minus, @eol, 2
numy	db	$C0 + (a02-$)
	db	@eol, 3

bloady	db	@pnd
	db	1, high (fspc-1), low (fspc-1)
	db	3

entery	db	$C0 + (bloady-$)
	db	$C0 + (a06-$), @eol, 3

a06	db	@lcma, @m, 2
	db	@lcma, @a, 4

listy	db	$C0 + (a05-$), 2
	db	$C0 + (a11-$)
	db	$C0 + (a13-$), 3

bsavey	db	@pnd
	db	1, high (fsav-1), low (fsav-1)
	db	$C0 + (a07-$), 3

a07	db	@grt, 7, @lcma

lomemy	db	7, @eol, 3	; lomem

dy	db	7
	db	$C0 + (a08-$), @eol, 3

a08	db	@lcma, 7, 4

cy	db	7, @grt
	db	$C0 + (a09-$), @eol, 3

a09	db	@lcma
	db	$C0 + (a09-$), 2, 7
	db	$C0 + (a10-$), 3

a10	db	@lcma
	db	$C0 + (a09-$), 4

qy	db	@doll, 7, @eol, 2, 8, @eol, 3		; ?
includy	db	@pnd
	db	1, high (fspc-1), low (fspc-1)
	db	@eol, 3


;	syntax expression
;	-----------------
bsx6	db	@def, ch, @defl, 2
	db	@grt, ch, @low, 2
	db	@less, ch, @high, 3

bsx3	db	@minus, ch, @umin, 2
	db	@not, ch, @notl, 2
	db	1, high (only1-1), low (only1-1)	; single unarys
	db	$C0 + (bsx6-$), 3

;  *** entry point

bsx	db	@olp				;[ exp ]
	db	$C0 + (bsx-$), @orp

	db	$C0 + (bsx1-$), 2		; op exp
	db	$C0 + (bsx3-$)			; unary exp
	db	$C0 + (bsx-$), 2
	db	$C0 + (bsx4-$)			; const op exp
	db	$C0 + (bsx1-$), 3

bsx1	db	$C0 + (bsx2-$)
	db	$C0 + (bsx-$), 4

bsx2	db	@minus, 2, @plus, 2
	db	@cpc, ch, @times, 2
	db	@mod, 2
	db	@div, 2, @and, 2, @or, 2
	db	@xor, 2, @cequ, 2, @lequ, 2
	db	@gequ, 2, @nequ, 2
	db	@grt, 2, @less, 2
	db	@bor, ch, @borl, 2
	db	@band,ch, @bandl, 3

bsx4	db	@cma,2
	db	1, high (tstlab-1), low (tstlab-1)	; label
	db	2
	db	1, high (hxdc-1), low (hxdc-1)		; hex/decimal #
	db	2, @cpc, 2, @apost
	db	1, high (tstasc-1), low (tstasc-1)
	db	2, @percent
	db	$C0 + (bsx5-$), 3

bsx5	db	8, 2, @lp
	db	0, low (bsx-1), high (bsx-1)		; param # exp
	db	@rp, 3

;	master syntax source line
;	-------------------------		;===== CAUTION ============
label	db	$C0 + (labels-$)		; NLABEL must follow LABEL...
nlabel	db	1, high (funt-1), low (funt-1)	;  assumed in assembly!!!
	db	3				; LABEL must not be on page
						;  boundary!!
labels	db	1, high (tstlabi-1), low (tstlabi-1)

;	inbedded table (save 1 byte)
;	----------------------------
oss:	db	$04, $46, $04, $10, $42


;======================================
;	Error messages
;	--------------
eres:	x_db	'ERROR - '
errtab	x_db	1,'MEM FULL'
	x_db	2,'BAD DEL'
	x_db	3,'BR RANGE'
	x_db	4,'NOT Z PAGE/IMM'
	x_db	5,'UNDEF'
	x_db	6,"EXP TOO C'PLX"
	x_db	7,'DUP'
	x_db	8,"O'FLOW"
	x_db	9,'IF/ENDIF'
	x_db	10,'# >255'
	x_db	12,'MACRO ERR'
	x_db	13,'PHASE'
	x_db	14,'*= UNDEF'
	x_db	17,'# >65535'
	x_db	18,'NO ENDM'
	x_db	21,'NESTED INCLUDE'
	x_db	23,'FILE TYPE'
	x_db	24,'LOAD TOO BIG'
	x_db	27,'BAD SET'
	x_db	xrerr,'TOO MANY X-REFS'
	x_db	hlocer,'TOO MANY LOCAL FIELDS'
	x_db	32,'BAD PARAMETER'
	x_db	nfpr,'NOT FP #'

	x_db	130,'NO DEV HANDLER'
	x_db	137,'TRUNCATED REC'
	x_db	138,'TIMEOUT'
	x_db	139,'NAK'
	x_db	144,'WRITE PROTECTED'
	x_db	160,'DRIVE #'
	x_db	161,'TOO MANY FILES'
	x_db	162,'DISK FULL'
	x_db	165,'FILE NAME'
	x_db	167,'LOCKED'
	x_db	170,'FILE NOT FND',0
errf	x_db	'(SEE MANUAL)'


;	print error message
;	-------------------
li1	rts	
_listerr:
	lda	eix		; any errors?
	beq	li1		; nope, return

	inc	errors		; bump error count
	pha			; save count
	lda	lstdv		; to device?
	beq	li0		; nope, just screen
	pha			; save device
	lda	#0		; list to e:
	sta	lstdv		; x
	jsr	le1		; do it
	pla			; pop list device
	sta	lstdv
li0	pla			; pop error count
	sta	eix

	lda	eaf		; ck mode
	beq	le1		; br if edit
	jsr	tstej		; ck eject
le1	lda	#bell		; ring bell
	jsr	charo
	ldx	#low eres	; print error
	ldy	#high eres	; message string
	jsr	ptst

le2	dec	eix		; pop index
	bmi	le0		; if done
	ldx	eix
	lda	errstack,x	; get er code
	beq	usrer		; user error
	cmp	#200		; pseudo cio err?
	bcc	le3		; no
	sbc	#200		; adjust code

le3	pha			; print err code #
	tax	
	lda	#0
	jsr	pdnum
	lda	#','		; print comma
	jsr	charo

	pla			; search message table
	jsr	same		; same messages?

	sta	fr1+2
	lda	#high errtab
	sta	fr1+1
	lda	#low errtab
le4	sta	fr1
	ldy	#0
	lda	(fr1),y
	beq	le7		; use default mess
	cmp	fr1+2
	beq	le8		; fnd mess, go print

le5	iny			; find start of
	lda	(fr1),y		; next message
	bpl	le5
	sec	
	tya	
	adc	fr1		; add y+1 offset
	bcc	le4		; to ptr
	inc	fr1+1
	bne	le4		; unc

usrer	clc	
	lda	strings
	adc	#strmax*2
	tax	
	ldy	strings+1
	bcc	le9		; error message
	iny	
	bcs	le9		; unc

le0	ldx	#0
	stx	eix		; clear err #
	jmp	docr		;***  done

le8	ldx	fr1		; bump to start
	ldy	fr1+1		; of mess
	inx	
	bne	le9
	iny	
	bne	le9		; unc

le7	ldx	#low errf	; default
	ldy	#high errf	; message
le9	jsr	ptst		; print string
	jsr	dosp		; space
	jmp	le2		; get next

same	proc
	ldy	#8
..sa1	cmp	smg,y
	beq	..sa2
	dey	
	bpl	..sa1
	rts	
..sa2	lda	sng,y
	rts	
	endproc


smg	db 11,31,30,16
	db 25,15,20,22
	db 19

sng	db 9,12,12,12
	db 23,8,8,8
	db 14


;	text line # test
;	----------------
lnum?:	proc
	jsr	afp		; dec #?
	bcc	glnm		; yup
	lda	#0		; nope, reset
	sta	cix		; text pointer & ret
	rts	

glnm	lda	nmfg		; in auto-num?
	beq	glnm1		; no
	bit	entdv		; entering auto?
	bmi	glnm1		; yes

	lda	cix		; handle atari e: quirk
	pha	
	jsr	afp		; second line #?
	pla	
	bcc	glnm2		; yes, forget 1st line#
	sta	cix		; no, restore input index
	bcs	glnm1		; unc

glnm2	lda	#$c0		; bit 6 => no auto incr
	sta	nmfg
glnm1	jsr	fpi		; f.p. to interger

	bcs	lerr		; if not interger
	ldy	fr0+1		; set search line #
	lda	fr0
	sty	srlnum+1
	sta	srlnum
	jmp	ok9		; go store num
lerr	lda	#17
	jsr	puterr
	endproc


;	editor auto number
;	------------------
numx:	proc
	jsr	anump		; set user para's
	bcc	nm3		; go if have slno
	jsr	fndli0

nm1	jsr	endl?		; statements end?
	bcs	nm2		; yup

	ldy	#0		; save this lineo
	lda	(stmcur),y
	sta	srlnum
	iny	
	lda	(stmcur),y
	sta	srlnum+1
	jsr	gtadoff		; point to next
	bcc	nm1		; unc, try again

nm2	clc			; add incr
	lda	srlnum		; to last lineo
	adc	numi		; and detect
	sta	lelnm		; overflow
	lda	srlnum+1
	adc	numi+1
	sta	lelnm+1		; x
	bcs	numerr		; oops!

nm3	lda	#$80		; sucess, set
	sta	nmfg		; auto flag here
	rts	

numerr	lda	#20
	jmp	puterr
	endproc


;	update cur line # for auto/ren
;	------------------------------
upcur:	proc
	clc			; add numi
	lda	lelnm		; to lelnm
	adc	numi		; and detect
	sta	lelnm		; overflow
	 lda	lelnm+1		; x
	 adc	numi+1		; x
	 sta	lelnm+1
	bcs	numerr		; no good!
	rts	
	endproc


;	number set-up for rep & num
;	---------------------------
; out:
;	cc	= starting lineo

anump	proc
	lda	#10		; set default increment
	sta	lelnm		; to 10
	sta	numi
	lda	#0		; high=0
	sta	lelnm+1
	sta	numi+1

	jsr	_getn		; number or carry
	bcs	anumset		; use defaults
	sta	numi+1		; use user
	stx	numi		; increments

	jsr	gtokel		; another number?
	beq	anumset		; no

	lda	numi		; user inc is now
	sta	lelnm		; starting lineo
	lda	numi+1
	sta	lelnm+1		; x

	jsr	_getn		; get user num inc
	sta	numi+1
	stx	numi

	clc			; set starting
	rts			; lineo
anumset	sec	
rj2	rts	
	endproc



;	editor renumber statement lines
;	-------------------------------
renx	proc
	jsr	anump		; set num paras
	jsr	fndli0		; get first line

rj1	jsr	endl?		; statements end?
	bcs	rj2		; yup

	ldy	#0		; set this lineo
	lda	lelnm		; equal to
	sta	(stmcur),y	; current lineo
	lda	lelnm+1
	iny	
	sta	(stmcur),y	; high byte
	jsr	upcur		; update current
	jsr	gtadoff		; point to nxt
	bcc	rj1		; unc, again
	endproc



;	editor delete
;	-------------
delx	proc
	jsr	lrng1		; set s&e lines
	bcc	dl1		; first l. fnd
deler	lda	#2		; invalid del
	jmp	puterr		; x

dl1	ldy	stmcur		; save stmcur
	ldx	stmcur+1	; x
	lda	lelnm		; move end line to
	sta	srlnum		; search line ptr
	lda	lelnm+1		; to calculate move size
	sty	lelnm		; put start adress
	stx	lelnm+1		; here for now

	jsr	fndli9		; search end line #
	bcs	nobump		; don't inc stmcur
	jsr	gtadoff		; contract at next line

nobump	sec			; get move size
	lda	stmcur
	sbc	lelnm		; x
	tay			; low byte in y
	lda	stmcur+1	; x
	sbc	lelnm+1		; high byte in a
	bmi	deler		; fatal!!!
	ldx	#stmcur		; table index
	jmp	contract	; contract & ret
	endproc


;	editor replace
;	--------------
repx	proc
	jsr	getslen		; get 1st string length
	sta	rps1		; save
	jsr	getslen		; get 2nd string length
	sta	rps2		; save
	lda	#$80		; set rep mode
	bne	fx1
	endproc


;	editor find
;	-----------
findx	proc
	jsr	gtoke
	cmp	#@pnd		; list to device?
	bne	fndx1		; no
	jsr	opnout		; handle filespec
	inc	cox		; skip comma

			; special procedure for filespec
	sec	
	lda	cmdlg		; adjust exbuf
	sbc	cox
	tax			; move size
	sec	
	lda	exbuf		; form move to
	sbc	cox		; address
	sta	inbuff		; temp pointer
	lda	exbuf+1
	sbc	#0
	sta	inbuff+1
	ldy	cox		; now, move 'em
..efr	lda	(exbuf),y
	sta	(inbuff),y
	iny	
	 dex	
	 bpl	..efr
	inx			; reset cox  x=0
	stx	cox

	jsr	fndx2		; execute find
	jmp	closel		; finish & return
	endproc


;	go find
;	-------
fndx1	proc
	dec	cox
fndx2	jsr	getslen		; get string length
	sta	rps1		; save
	lda	#0		; set find mode

fx1	sta	rpfd
	inc	dspflg		; for control chars
	jsr	getpa		; set s&e lineos

	ldy	cmdlg
fx2	lda	(exbuf),y	; move command line
	sta	(repbuf),y	; to safe place
	dey	
	bpl	fx2

fx3	lda	#$80		; clear inbuff flag
	sta	rpif
	jsr	lline		; past last line?
	bcs	fx0		; yup
fx4	jsr	testbk		; break?
	bne	fx0		; yup

	bit	rpif		; did rep cause delete
	bvs	fx3		; yup

fx5	jsr	isrch		; go match string
	bcs	fx6		; no match!
	lda	rpfd		; check mode
	bne	rx1		; br if rep
	jsr	inbout		; display line
	lda	rpoc		; first occurance?
	beq	fx0		; yup

fx6	jsr	gtadoff		; point to next
	jmp	fx3
fx0	rts	
	endproc


			; replace module
rx1	lda	rpoc		; in querry?
	bpl	rx4		; no
	jsr	inbout		; list line

rx2	lda	#'?'		; prompt
	jsr	charo
	jsr	intlbf		; fail safe!
	lda	#0		; force $500 buf
	sta	inbuff
	jsr	egli1		; get line
	jsr	intlbf		; reset buff
	jsr	testbk		; abort?
	beq	rx3		; no
..rex	jmp	prmpt		; ret to edit

rx3	lda	lbuff-$80	; get responce
	cmp	#'Y'		; yes?
	beq	rx4		; exchange!
	cmp	hcntrlc		; aborting?
	beq	..rex
	cmp	#eol		; no exchange?
	bne	rx2		; no, go reprompt

	inc	rpsp		; point to nxt,
	jmp	fx5		; continue

rx4	lda	rps1		; form string diff
	sec	
	sbc	rps2
	sta	temp		; save
	lda	rpll		; form new
	sec			; inbuff end
	sbc	temp
	pha			; save
	cmp	rpll		; check against old
	beq	equal		; br if =
	bcs	movup		; br if >

	lda	rpop		; form move from
	adc	rps2		; inbuf index
	tax	
	ldy	rpsp		; mvta index
mvdw	inx			; bump mvfa
	iny			; bump mvta
	lda	lbuff,y		; move until eol
	sta	lbuff,x
	cmp	#eol
	bne	mvdw		; another byte
	beq	equal		; unc

movup	tax			; mvta inbuf index
	ldy	rpll		; mvfa inbuf index

mup	lda	lbuff,y		; move byte
	sta	lbuff,x
	dex			; pop indices
	dey	
	cpy	rpsp		; at cur ptr?
	bne	mup		; no

equal	pla			; new inbuff
	sta	rpll		; string length
	lda	rpsp		; form new current
	sbc	temp		; inbuff ptr (cs)
	sta	rpsp
	inc	rpsp		; and bump it

	lda	rps2		; string 2 length
	beq	rx6		; br if zero
	sta	temp		; save
	ldy	rpse		; start 2nd string -1
	ldx	rpop		; old inbuf ptr

rx5	iny			; bump
	inx	
	lda	(repbuf),y	; move new char
	sta	lbuff,x		; to inbuf
	dec	temp		; pop cnt
	bne	rx5		; br if not done

rx6	lda	#rmode		; syntax this
	sta	epf		; line
	lda	#0		; clear syntax pointers
	sta	cix		; current input
	sta	saxtx		; syntax valid
	sta	cox		; current output
	jsr	skpspace
	jsr	konvert		; handle lower case
	jmp	very		; hidden jsr

veryr:	lda	#0		; ret here unless
	sta	epf		; syntax err
	bit	system		; display the line?
	bvs	..nd
	jsr	inbout		; yes, display line

..nd	lda	rpoc		; first occur?
	beq	ss0		; yup, ret
	jmp	fx4		; no, do nxt
	endproc



;	inbuff string search
;	--------------------
; out:
;	cc = found; cs = not fnd

isrch	proc
	lda	rpif		; inbuf have line?
	beq	ss1		; yup
	jsr	setztab		; reset zp tabs
	jsr	movin		; move to inbuff
	ldy	cix		; inbuf length +1
	dey			; pop
	sty	rpll		; save
	ldy	#0
	sty	rpif		; clear inbuf flg

ss1	dec	rpsp		; init inbuf index
ss2	ldy	#0		; clear pointer to rep buff
	sty	rpcl
	lda	rpsp		; save current pointer
	sta	rpop

ss3	inc	rpcl		; pt to nxt char
	ldy	rpcl		; check ptr
	cpy	rpse
	bcs	ss5		; at end, fnd

	lda	(repbuf),y	; get char
	inc	rpsp		; inc inbuf ptr
	ldy	rpsp
	cpy	rpll		; check ptr
	bcs	ss0		; at end, not fnd

	cmp	lbuff,y		; they match?
	beq	ss3		; yup, get nxt
	ldy	rpop		; old inbuf index
	iny			; bump
	sty	rpsp		; as new srch index
	bne	ss2		; unc
ss5	clc	
ss0	rts	
	endproc




;	init for find & replace
;	-----------------------
getpa	proc
	jsr	lrng1		; set s&e lineo
	jsr	gtokel		; if eol, then set
	beq	gpa2		; first occurance

	jsr	gtoke
	ldx	#$ff		; set for querry
	cmp	#@a		; is it "a"?
	bne	gpa1		; no
	ldx	#1		; set all occurance
	 db $2C

gpa2	ldx	#0		; first occurance
gpa1	stx	rpoc		; set q, a, or 1st

	ldx	rps1		; get string length
	inx			; bump and save as
	stx	rpse		; end for string test
	lda	#0		; list line #
	sta	supr
	rts	
	endproc



;	auto-number
;	-----------
an0	proc
	sta	nmfg		; reset bit 6
	jsr	upcur		; do the auto update
			;  fall for re-try
autonum:
	lda	lelnm		; search for
	sta	srlnum		; cur line
	sta	fr0
	lda	lelnm+1
	sta	srlnum+1
	sta	fr0+1
	bit	entdv		; enter with auto?
	bmi	an1		; yup, skip!
	jsr	fndli
			;   if not in memory,
	bcs	an1		; do this num

	lda	#$80		; maybe special case?
	bit	nmfg		; if bit 6: special
	bvs	an0
	asl	a		; a=0, clear
	sta	nmfg		; auto-num & ret
	jmp	prmpt

an1	jsr	prdn		; print lineo
	lda	#$A0		; and space
	jsr	enters
	ldy	svn2		; clean up
	lda	(inbuff),y	; inbuf lineo
	and	#$7f		; x
	sta	(inbuff),y
	iny	
	lda	#$20		; lineo + space
	sta	(inbuff),y
	iny	
	sty	svn2
	clc	
	tya	
	adc	inbuff
	sta	inbuff
	lda	#127		; form new buff
	sec			; start adr
	sbc	svn2
	tay	
	jsr	stext		; set cio text
	jsr	io3		; do cio
	jsr	getstat		; ck stat
	jmp	intlbf		; ret
	endproc



;	set-up line number range
; 	for list, print, find, & rep
;	----------------------------
lrng1	proc
	jsr	gtoke
lrnge:	ldy	#0		; default to
	sty	srlnum		; line 0 through
	sty	srlnum+1	; line 65535
	dey	
	sty	lelnm
	sty	lelnm+1

	jsr	_getne		; get num or carry
	bcs	..lr2		; no number
	sta	srlnum+1	; set start &
	sta	lelnm+1		; end line
	stx	srlnum		; numbers equal
	stx	lelnm

	jsr	gtokel		; done?
	beq	..lr2		; yup, all set

	cmp	#@minus		; for "list exp,"
	bne	..lr8
	lda	#-1		; set default lelnm
	sta	lelnm
	sta	lelnm+1
	bcs	..lr7		; unc

..lr8	jsr	_getn		; number or carry
	bcs	..lr1
	sta	lelnm+1		; save end
	stx	lelnm		; line number
	bcc	..lr7		; unc, find start l.

..lr1	dec	cox		; pop to spec
..lr2	dec	cox		; pop to eol/spec
..lr7	jmp	fndli		; fall thru to "fndli"
	endproc



;	editor size
;	-----------
sizex	proc
	lda	lomem		; print lomem
	ldy	lomem+1
	jsr	hexw
	jsr	space3		; three spaces

	lda	txtend		; print top of text
	ldy	txtend+1
	jsr	hexw
	jsr	space3

	lda	mtp		; print high mem
	ldy	mtp+1

si	jsr	hexw		; print hex word
	jmp	docr		; do eol & ret
	endproc



;	editor hex/dec-dec/hex convert
;	------------------------------
qx	proc
	lda	#'='		; print leading =
	jsr	charo
	jsr	gtoke
	cmp	#@doll		; dollar sign?
	bne	tohex		; nope

	jsr	_getn
	jsr	pdnum		; go print it
	jmp	docr		; do eol & ret

tohex	pha			; dec to hex convert
	lda	#'$'		; leading $ sign
	jsr	charo
	pla	
	jsr	_getne		; get number
	tay			; swap for
	txa			; print routine
	jmp	si		; go print it
	endproc



;	editor lomem
;	------------
lomemx	proc
	jsr	_getn		; get new lomem
	stx	svlomem		; adress
	sta	svlomem+1
	jmp	newx		; clear all pointers
	endproc
