$eject
;===========================
;	MAC65 equates
;===========================

;	master & key equates
;	--------------------
atari	equ	1	; machine flag
apple	equ	!atari

oss?	equ	1	; in house version
cbug	equ	0	; cartridge debug (banks are for $C000 for Mosaic)
ddt?	equ	1	; assemble with DDT
ram	equ	1	; for ram cart assembly
eprom	equ	0	; for eprom burning

@@base	equ	$3000	; ram assembly addr
sorcim	equ	1	; sorcim locals
pseude	equ	0	; drive #3
toggle	equ	0	; toggle list dev
dolocal	equ	0	; asm only locals

; for rom assembly (cbug=0 and @@base=$3000)

;            ______________________________
;object addr | $3000  $4000 | $5000  $6000 |
;actual addr | $a000  $b000 | $a000  $a000 |
;group/bank  | bankc   main | banka  bankb |
;            |  - - - - - - |  - - - - - - |
;            |  master chip |  slave chip  |
;            ______________________________

rom	equ	$b000
	$if cbug
romf	equ	  $c000
bank1	equ	  $ffc0
bank2	equ	  $ffc1
bank3	equ	  $ffc2
	$else
romf	equ	  $a000
bank1	equ	  $d500
bank2	equ	  $d509
bank3	equ	  $d501
ramall	equ	  $d508
	$endif


; Memory areas
; ------------
fr0	equ	$d4
fr1	equ	$e0
raz1	equ	$80
raz3	equ	$fb
zfp	equ	$d2
cix	equ	$f2		; input text index
inbuff	equ	$f3		; indirect to lbuff
ztemp4	equ	$f7		; syntax hex temp +2
ztemp3	equ	$f9		; used ascii to f.p.
xrefsz	equ	ztemp3		; asm x-ref total size

	$if oss?
tpobuf	equ	  $0600		; asm obj buf +128
	$endif			; & syntax text use

ram2	equ	$0480		; non-zpage usage
ram3	equ	$0500		; secondary non-zpage
lbuff	equ	$0580

;	syntax stack +128
;	-----------------
six	equ	ram3		; syn save cix
sox	equ	six+1		; syn save cox
spc	equ	six+2		; syn save pc +2


; assembler buffer allocation buffer size must be in multiples of pages.

bufsize	equ	6*256		; set 1.25k


;	z-page memory management ptrs
;	-----------------------------
	seg	absolute
	org	raz1
lomem			; token buff
exbuf	ds	2	; execution buff

objbuf			; asm obj buff
repbuf	ds	2	; rep string buff

txttab	ds	2	; start of txt
stmcur	ds	2	; cur line ptr

txtend			; text end
asmram	ds	2	; assembly buffers

stack	ds	2	; parameter stack
macstrt	ds	2	; macro def

macend			; macro end
smbltp	ds	2	; symbol tab start

smblend			; symbol tab end
memtop	ds	2	; top of used mem


;	routine & table pointers
;	------------------------
cox	ds	1	; cur exec buf indx

srcadr			; search adr
msgadr	ds	2	; pr string adr

svesa	ds	2	; mangr sv strt adr

labpt			; asm ptr: = & list
saxpc			; syntax pc
rfpgn	ds	2	; x-ref page # count

objix			; asm temp obj ptr
saxtx	ds	1	; syntax valid ptr

usadr			; utility adr ptr
srlnum			; sv line # for srch
labof	ds	1	; lab handler use

augx	ds	1	; macrox argument temp

mvsiz			; mangr move size
slsz	ds	2	; save/load file sz


;	working variables
;	-----------------
stklvl			; stntax stack ptr
mcrsk	ds	1	; macrox stack ptr

skipfc			; search skip indx
modfybyt		; byte modifier value
sverr	ds	1	; save error code

lelnm			; list end line# +2
ueadr			; utility end adr +2
link			; x-ref test link +2
res	ds	1	; asm exp resolved

curaug	ds	1	; macrox para ptr

; next group must stay together
; * - these locations are poison

eaf	ds	1	; edit/pass # flg*
nmfg	ds	1	; auto flg
epf			; edit/rep flg*
rfpagf	ds	1	; x-ref flags (bits)

eix	ds	1	; err indx
entdv	ds	1	; enter dev
lstdv	ds	1	; list dev
refdv	ds	1	; x-ref dev
supr	ds	1	; supres list l. #

group	equ	$-eaf-1	; locs in group

txtflag	ds	1	; text mode flag


;	misc locations
;	--------------
bcode			; asm base code
dirfg			; asm which directve
numi	ds	1	; auto inc +2

bfld			; asm fld ofset
tem			; macro def temp
tem0	ds	1	; macrox temp

asmpc			; asm pc +2
condptr	ds	1	; syn cond text

actptr			; syn actual text
hdcix	ds	1	; temp for cix

zt1			; asm object list
mode			; asm multi adr typ
maxsort			; sort largest len
temp	ds	1	; local temp

curtoke			; syn cur tst toke
ltemp			; asm lab process
cmdlg	ds	1	; internal line len

rps1			; rep 1st str len
rstk	ds	1	; conditional stk ptr

rpsp	ds	1	; rep str ptr, list

rpll			; rep inbuf str len
svop			; ex exp sv opertor
torg	ds	1	; disasm test origin +2

rpop			; rep old line ptr
svnp	ds	1	; ex exp sv on prec

rpcl			; rep cur line ptr
inmac	ds	1	; macrox in-process

ztab1	ds	1	; z-page tab list*
ztab2	ds	1	; z-page tab list*


;	do not relocate the next three pointers!!!
;	------------------------------------------
			; bload header +4
buffer	ds	2	; asm sliding buffer pointer
bytcnt	ds	2	; asm byte counter for this read
filesize
	ds	2	; asm source file size

objptr	ds	1	; asm obj buf indx
xrefbufi
	ds	2	; x-ref pointer
real	ds	1	; asm master pass #
sxref	ds	1	; save x-ref option

xrindx			; 'xrefbuf' index
rpoc	ds	1	; rep occurance
ionum	ds	1	; save iocb #
ciocmd	ds	1	; save cio command
asmlino	ds	2	; asm current lineo +2

rpse			; rep 1st str end
localix	ds	1	; local label counter

rpfd			; rep or find flg
pcdef	ds	1	; asm pc def flg
eofflag	ds	1	; asm eof flag

rpif			; rep inbuff flag
linecnt	ds	1	; lines/page cntr
column	ds	1	; list column count
pagenum	ds	2	; page cntr +2

system	ds	1	; internal sys flags
			;   bit 7:  find/rep start at label
			;           colunm (=0) or at first colunm
			;           after line #.
			;   bit 6:  rep re-list of line
			;           after replace (=0) is list.
			;   bit 5:  local labels appear
			;           in symbol table printout.

	org	zfp-2
svn2	ds	1	; syntax use
svf2	ds	1	; syntax use
rps2			; rep 2nd str len
mpf	ds	1	; asm pass 2/3 flag
objdv	ds	1	; object device

	org	fr0
many	ds	2	; asm cio byte cnt+1
fwdptr			; sort foward ptr
lablst	ds	1	; list label start
lablch	ds	1	; list label index
bckptr	ds	2	; sort back ptr

; *** start of "fre"
	ds	1		; unused- not safe

svcpc			; pass 3 sv pc +2
xrfchar			; x-ref list char
xrfrdo	equ	$+1	; x-ref single ref flag
	ds	2

svstm			; pass 3 sv stmt
lastl	ds	2	; x-ref last line #
errors	ds	1	; asm error count

	org	fr1
swapsort		; sort exc flg
lablsz	ds	1	; list label size

hilosort		; sort len flg
lablcc	ds	1	; list label column
sindex	ds	1	; sort/list char index
topstk	ds	1	; ex exp push flag

labelptr		; sort/list lab ptr +2
aptr	ds	1	; ex exp oper ptr
optr	ds	1	; ex exp argument ptr

;  *** start of "fr2"

mvfa			; mem mgr mv fr
sltmp	ds	2	; save/load temp
mvta			; mem mgr mv to
ktmp	ds	2	; "pdum" iocb indx +1


mvlgn			; mangr move len
amvta			; asm io move to addr (temp)
zte4	ds	2	; list decimal # temp

;  *** start of "frx"

buffers	ds	2	; asm io buffers ptr
strings	ds	2	; asm string space ptr
bufferx	ds	2	; x-ref buffer ptr

	org	raz3
klist	ds	1	; device master list
optflag	ds	1	; asm option flg
ttix	ds	1	; list exbuf index

tobjdex			; asm byte list
mnindx	ds	1	; disasm mnemonic index
commode	ds	1	; asm temp (.byte)

	org	ram2
xcii	ds	2	; os/a+ system use
hcntrlc	ds	1	; control-c abort char
colors	ds	2	; save system color
errstack
	ds	3	; error stack +3
svlomem	ds	2	; save lomem
tab1	ds	1	; list tab setings
tab2	ds	1	; x
tab3	ds	1	; x
pointer	ds	3	; asm 'point' +3
oldentdv
	ds	1	; .include save device
bufftab	ds	6	; asm buffer table


; system ".set" storage
; there are 6 sets

sysset
setbyte	ds	1	; .byte & .sbyte format
leftmar	ds	1	; left margin
rightmar
	ds	1	; right margin
topfc	ds	1	; top of form char
formsz	ds	1	; physical page size
cpad	ds	1	; comment space padding
offset	ds	2	; offset to object
sysmax	equ	$-sysset-1	; number of sets

runstk	ds	18	; conditional stack
skmx	equ	$-runstk	; run stk top

; macro stack
; -----------
svcur	equ	$	; macrox sv stmcur
svaug	equ	$+2	; sv param ptr
svedv	equ	$+3	; sv enter dev
	ds	68	; stack size
topsk	equ	$-svcur	; macro stk top

savdevi	ds	6	; asm save pointers +6
spointer
	ds	56	; label pointers +56
xrefbuf	ds	32	; x-ref line buffer
xrmax	equ	$-xrefbuf	; top of buffer
;fz	equ	20
fz	equ	16	; filespec buffer size		(CART ver... was 20
asmfm	ds	fz	; main filespec for list	  in steves version..)
asmfi	ds	fz	; include filespec
	ds	0	; where we are

; misc working equates
; --------------------
tosa	equ	$c8	; exexpr set stack
tose	equ	$ff-tosa	; exexpr tos
argops	equ	$0100+tosa	; ex exp stack
strmax	equ	80	; reserve string space
ckbyt	equ	$fe	; save/load ck byte
@@sx	equ	$82	; instr stx
@@sy	equ	$80	; instr sty
@	equ	$c0	; for syntax tables
ch	equ	9	; syntax change
thw	equ	ch-4	; token hex word
thb	equ	ch-3	; token hex byte
tdw	equ	ch-2	; token dec word
tdb	equ	ch-1	; token dec byte
rmode	equ	$77	; rep on mode

	$if ddt?
dmode	equ	$00	; ddt swap flag
	$endif

eof	equ	$88	; atari eof
eol	equ	$9b	; atari eol
bell	equ	$fd	; atari bell
tab	equ	$7f	; atari tab

cntrlc	equ	3	; control-c auto abort
linefeed equ	$0a	; line feed
topform	equ	$0c	; top of form

qdumy	equ	0	; nested null
qelse	equ	1	; search endif/else
qselse	equ	2	; else found
qendif	equ	3	; search else
rfnum	equ	-121	; x-ref word type
rfnub	equ	-122	; x-ref relative
rfpag	equ	-123	; x-ref page number
rflab	equ	-124	; x-ref label flag
rfeof	equ	-125	; x-ref eof

;  *** error numbers
ntpe	equ	9	; nesting
sofe	equ	11	; conditional stk
nesr	equ	12	; macro nest
dupm	equ	16	; dup macro name
lmr	equ	18	; linked macro def
xrerr	equ	28	; too many x-refs
hlocer	equ	29	; too many local fields
udfm	equ	30	; undef macro
nesm	equ	31	; macrox nesting
nfpr	equ	33	; floating point #


; *** cio equates
; ---------------
aphm	equ	$0e
warmflg	equ	$08	; warm start?
icdno	equ	$0341
iccom	equ	$0342
icsta	equ	$0343
icbufa	equ	$0344
icput	equ	$0346
icbufl	equ	$0348
icaux1	equ	$034a
icaux2	equ	$034b
icsec	equ	$034c
icbyt	equ	$034e
xcio	equ	$e456
ataribye equ	$e471	; memo pad
icax1z	equ	$2a	; z-page iocbs
icax2z	equ	$2b

; routines in floating point roms
; -------------------------------
ilshift	equ	$da5a
skpspace equ	$dba1
intlbf	equ	$da51
afp	equ	$d800
ifp	equ	$d9aa
fpi	equ	$d9d2
fascc	equ	$d8e6

dosvec	equ	$0a
brkkey	equ	$11
coldst	equ	$0244
tabmap	equ	$02a3
color1	equ	$02c5
color2	equ	$02c6
mtp	equ	$02e5		; highest available
memlow	equ	$02e7
chr	equ	$02fc
dspflg	equ	$02fe
ssflag	equ	$02ff

consol	equ	$d01f
pokey	equ	$d200
skctl	equ	$d20f


$eject
;============================
;	DDT EQUATES
;============================

; warm start location is ddtwrm
; zero page definitions

pokmsk	equ	$10
rtclok	equ	$14

; page 2 definitions
; ------------------
vbreak	equ	$0206
vkeybd	equ	$0208
vvblki	equ	$0222
vvbkih	equ	$0223
vvblkd	equ	$0224
vvbkdh	equ	$0225
sdmctl	equ	$022f
sdlstl	equ	$0230
sdlsth	equ	$0231
gprior	equ	$026f
color4	equ	$02c8
crsinh	equ	$02f0
chact	equ	$02f3
chbas	equ	$02f4


; hardware registers
; ------------------
grafp0	equ	$d00d
gractl	equ	$d01d
kbcode	equ	$d209
irqen	equ	$d20e
dmactl	equ	$d400
dlistl	equ	$d402
vcount	equ	$d40b
nmien	equ	$d40e


; os addresses
; ------------
kchact	equ	$e002	;note - this will load chact & chbas
kvvbki	equ	$e45f	;standard vector
kvvbkd	equ	$e462	;standard vector


; other definitions
; -----------------
bordr	equ	$04	;border color
bkgnd	equ	$00	;background color
text	equ	$0a	;text luminance
dbchr	equ	$9c	;flash character (control esc now)

	org	lomem+2
windf	ds	1	;init 0
zpsflg	ds	1	;zero page swapped flag for reset
undff	ds	1
asav	ds	1
xsav	ds	1
ysav	ds	1
spsav	ds	1
psav	ds	1
pcsav	ds	2
poksav	ds	1
dindir	ds	2
dndr2	ds	2
dscnfl	ds	1
btemp	ds	2
itemp	ds	1
chcol	ds	1
examwi	ds	2
cc	ds	1
fsize	ds	1
hexval	ds	2
mprot	ds	1
tbyte	ds	1
stemp	ds	2
itbyte	ds	1
sssiz	ds	1
sstr	ds	6


	org	$03fd		;start of cassette buffer
grsav	ds	13
brkor	ds	1
vkeysv	ds	2	; save keyboard irq vector
crstat	ds	1
depsw	ds	1
ddtact	ds	1	; init 83
ssflg	ds	1
dscd1	ds	284	; display lines for window
dscd2	ds	32	; display line for brkps.
dscd3	ds	32	; display line for registers
brkp0	ds	15	; init 0

	org	$05ff-10
tbed	ds	3	; for displaced instruction
	ds	3	; init jmp ssret
	ds	3	; init jmp ssbc2
