$title(MAC65/XL Cartridge  (c) 1988 ICD Inc)
$subtitle(Cartridge main bank for MAC65)
$include "equate.asm"
$include "tokens.asm"

	seg	main
;=================================
;	Process source line
;=================================

;	process text line, handle control c auto-num exit here
;	------------------------------------------------------
ptext:	proc
	ldy	cix		; get 1st character
	lda	(inbuff),y
	cmp	#eol		; if eol, delete
	beq	..dell

	sty	hdcix		; save "cix"
	jsr	skpspace	; is line
	lda	(inbuff),y	; all spaces?
	cmp	hcntrlc		; auto abort?
	bne	..hnc		; no
	 lda	#0		; else, stop auto
	 sta	nmfg
	 jmp	warm		; go warm start

..hnc	cmp	#eol		; null line?
	bne	..hnsp		; no
	lda	epf		; replace mode?
	beq	..nrep		; no
..dell	 jmp	dell		; consider as delete
..nrep	jmp	noprm		; next input

..hnsp	ldy	hdcix		; reset "cix"
	sty	cix
	inc	cox		; dummy for offset
	jsr	synli		; syntax line
	ldy	#2
	dec	cox		; pop line eol
	lda	cox		; this is offset
	sta	(exbuf),y	; to next line

	jsr	fndli		; look for line
	lda	#0		; set for not found
	bcs	..skp		; br: line isn't there
	 jsr	getoset		; get current length

..skp	sec			; find diff
	sbc	cox
	beq	samez		; same size
	bcs	smallz		; smaller

	jsr	exptxt		; go expand
	lda	svesa		; restore current
	sta	stmcur		; line pointer
	lda	svesa+1
	sta	stmcur+1
	bne	samez		; unc

smallz	pha			; set-up contract
	jsr	adoff		; adress
	pla	
	jsr	contxt		; and contract

samez	ldy	cox		; move new line
..mv	dey			; to memory
	lda	(exbuf),y
	sta	(stmcur),y
	tya	
	bne	..mv

	ldy	#3		; check for bad line
	lda	(stmcur),y	; non-zero
	bne	oj		; if sucess
	 sta	supr		; do pr line #
	 sta	epf		; clr rep rts flg
	 jsr	setztab		; set zp tabs
	 jsr	prli		; print bad line

oj	bit	nmfg		; auto?
	bpl	oy		; no
	bvs	oy		; special- atari quirk
	 jsr	upcur		; update next line #

oy:	lda	epf		; are we in
	cmp	#rmode		; replace mode?
	beq	rtrep		; yup
	 jmp	noprm		; else, to editor

rtrep	jmp	veryr		; to replace
	endproc



;	Get line of text from E:
;	------------------------

input:	proc
	jsr	intlbf
inp	jsr	egli		; get a line
	cmp	#eof		; eof?
	beq	inp		; yup

	lda	#0		; clr:
	sta	cix		; input index
	sta	saxtx		; valid text pointer
	sta	cox		; output index
	jsr	skpspace
	jsr	testbk		; check break key
	beq	yline		; no break
	 ldy	#0		; clear auto
	 sty	nmfg
	 dey			; reset flag
yline	rts	
	endproc



;	Editor list and print
;	---------------------
printx:	proc
	lda	#$80		; supress line #
	 db $2c

listx:	lda	#0		; set print line #
	sta	supr
	jsr	setztab		; set z-tabs
				;  atari display
	inc	dspflg		; control chars

	jsr	docr		; a formality...
	jsr	gtoke
	cmp	#@pnd		; to a device?
	bne	..lx1		; no

	jsr	opnout		; handle filespec
	jsr	..lx2		; handle listing

closel:	lda	lstdv		; close device
	jsr	closei
zldv0	lda	#0		; reset back
	sta	lstdv		; to e: driver
..lx3	rts	

..lx2	jsr	gtokel		; ckeck ", lineo"
	beq	..lx1
	 jsr	gtoke		; get next token

..lx1	jsr	lrnge		; get s&e lineo's
..lx4	jsr	testbk		; break abort?
	bne	..lx3		; yup
	jsr	lline		; past last line?
	bcs	..lx3		; yes
	jsr	prli		; print this line
	jsr	testbk		; if middle of l.
	bne	..lx3		; yup
	jsr	gtadoff		; point to next
	bcc	..lx4		; unc loop
	endproc


;	Line number search (find lineo in srlnum)
;	-----------------------------------------

fndli0:	proc
	lda	#0
	sta	srlnum
fndli9:	sta	srlnum+1

fndli:	jsr	endl?		; at memtop?
	bcs	..fl1		; start at txttab

	ldy	#1		; see if lineo >
	lda	(stmcur),y	; last line
	cmp	srlnum+1	; x
	bcc	..fl2		; less, start at stmcur
	bne	..fl1		; start at txttab

	dey			; low byte
	lda	(stmcur),y	; x
	cmp	srlnum
	bcc	..fl2		; start at stmcur
	beq	..fl5		; at line, return

..fl1	lda	txttab+1	; set ptr to
	ldy	txttab		; start of
	sta	stmcur+1	; text file
	sty	stmcur		; x

..fl2	jsr	endl?		; begin search
	bcs	..fl3		; stop if text top
	ldy	#1		; high
	lda	(stmcur),y	; x
	cmp	srlnum+1
	bcc	..fl4		; less, pt to nxt
	bne	..fl3		; end
	dey			; low
	lda	(stmcur),y	; x
	cmp	srlnum
	bcc	..fl4		; less, pt to nxt
	bne	..fl3		; br: not found
..fl5	clc			; equal, set fnd
..fl3	rts	

..fl4	jsr	gtadoff		; bump stmcur
	bcc	..fl2		; unc
	endproc


;	get offset of stmcur in a
;	-------------------------
getoset: proc
	ldy	#2
	lda	(stmcur),y
	rts	
	endproc


;	bump stmcur to next stmcur
;	--------------------------
; out:
;	cc

gtadoff: proc
	jsr	getoset		; get offset

adoff:	clc	
	adc	stmcur
	sta	stmcur
	bcc	..ff
	 inc	stmcur+1
	 clc	
..ff	rts	
	endproc



;==================================
;	Editor - ENTER file
;	-------------------
enterx:	proc
	jsr	hfile		; handle filespec
	jsr	gtokel		; merge?
	beq	..ncl		; yup, clear & boot

	jsr	gtoke		; get enter option
	cmp	#@m		; check merge first
	beq	..ncn		; yup, merge

	jsr	enttxt		; clear memory
	lda	entdv		; set "special" enter
	ora	#$80
	sta	entdv
	jsr	numx		; do auto-number
	jmp	noprm		; go get input

..ncl	jsr	enttxt		; clear memory
..ncn	jmp	noprm		; go for input
	endproc


;===============================
;	Editor - LOAD file
;	------------------
loadx:	proc
	jsr	hfile		; handl filespc
	jsr	gtokel		; load with append?
	bne	loapp		; yup
	 jsr	enttxt		; no, clear memory

loapp	jsr	gobj		; pop check byte
	cmp	#ckbyt		; save file?
	bne	..loabt		; no, abort it!
	jsr	gobj		; next check byte
	cmp	#ckbyt		; ok?
	beq	..loap1		; yup

..loabt	lda	#200+23		; pseudo cio err
ero	jmp	badst


..loap1	jsr	gobj		; get file size
	sta	slsz
	jsr	gobj
	sta	slsz+1

	clc			; calculate new
	lda	txtend		; mem top and ck
	adc	slsz		; for overflow
	sta	sltmp
	tay	
	lda	txtend+1
	adc	slsz+1
	bcs	er24		; file too big!!!
	 sta	sltmp+1

	cmp	mtp+1		; ckeck for val>memtop
	bcc	loalp
	bne	er24		; oops
	cpy	mtp
	bcc	loalp
	beq	loalp

er24	lda	#24+200		; load too big
	bne	ero

loalp	ldx	entdv		; get enter dev
	lda	#7		; get chars cmd
	jsr	blkio1		; set some cio

	lda	txtend+1	; set "load at"
	ldy	txtend		; adress
	jsr	io4		; go get 'em
	cpy	#$80		; fix: test for break
	beq	loabrk		; don't set memtop
	jsr	getstat		; get status

	lda	sltmp		; get new mem top
	ldy	sltmp+1
	ldx	#txtend		; set rest of
	jsr	cs1		; z-page pointers

loabrk	lda	entdv		; close dev
	jsr	closei
	lda	#0		; reset enter device
	sta	entdv		; to e:
	rts			; return
	endproc


;================================
;	Editor - BLOAD file
;	-------------------
bloadx:	proc
	jsr	hfile		; handl filespc
	jsr	gobj		; pop ck bytes
	cmp	#$ff		; bsave?
	bne	..nbsv		; no
	jsr	gobj		; x
	cmp	#$ff		; bsave?
	bne	..nbsv		; no

..top	lda	#7		; get binary cmd
	jsr	glcxent		; set-up
	lda	#4		; get header
	sta	icbufl,x
	lda	#0
	sta	icbufl+1,x
	ldy	#low buffer	; AY = address of buffer
	jsr	io4.s		; do it!

	sec			; Now load the bytes
	lda	buffer+2	; end addr -
	sbc	buffer		; start addr
	sta	icbufl,x	; to iocb
	lda	buffer+3
	sbc	buffer+1
	sta	icbufl+1,x
	inc	icbufl,x
	bne	..b00
	 inc	icbufl+1,x

..b00	ldy	buffer		; the dest addr
	lda	buffer+1
	jsr	io4
	cpy	#1		; only perfect status
	beq	..top		; still more to do
	jsr	getstat
	jmp	loabrk		; tidy-up

..nbsv	lda	#25+200		; not bsave err
	jmp	badst
	endproc


;================================
;	Editor - SAVE file
;	------------------
savex:	proc
	jsr	fobjcx		; handle filespc

	lda	#ckbyt		; out check bytes
	jsr	outax

	sec			; calculate file
	lda	txtend		; size for cio
	sbc	txttab
	sta	slsz
	tax			; low byte
	lda	txtend+1
	sbc	txttab+1
	sta	slsz+1		; high byte
	jsr	out2		; out file size
	jsr	blkio		; block io set

	lda	txttab+1	; get adr of
	ldy	txttab		; file start
sav1	jsr	io4.s		; go do it!

	lda	objdv		; close this file
	jmp	closei		; return
	endproc


;=================================
;	Editor - BSAVE file
;	-------------------
bsavex:	proc
	jsr	fobjcx		; handle filespc
	inc	cox		; skip < sign
	jsr	outff		; binary save header

	jsr	_getn		; get start addr
	sta	sltmp+1		; for bsave
	stx	sltmp
	jsr	out2		; out start addr

	inc	cox		; skip comma
	jsr	_getn		; get end address
	sta	slsz+1
	stx	slsz
	jsr	out2		; out end addr

	sec			; form file size
	lda	slsz
	sbc	sltmp
	sta	slsz
	lda	slsz+1		; hi byte
	sbc	sltmp+1
	sta	slsz+1
	inc	slsz		; fix, bump size
	bne	..f1f
	 inc	slsz+1

..f1f	jsr	blkio		; set cio
	lda	sltmp+1		; get file start
	ldy	sltmp		; adress
	jmp	sav1		; go to it
	endproc



;=====================================
;	Editor text line tests
;=====================================

;	Test for text end
;	-----------------
endl?:	proc
	lda	stmcur+1
	cmp	txtend+1
	bcc	ll0
	bne	ll0
	 lda	stmcur
	 cmp	txtend
ll0	rts	
	endproc


;	Test for end of line range
;	--------------------------
lline:	proc
	jsr	endl?		; at text end?
	bcs	ll0		; yes

;	Test stmcur against lelnm
;	-------------------------
el1	proc
	ldy	#1
	lda	(stmcur),y
	cmp	lelnm+1
	bcc	..el2
	bne	..el2
	 dey	
	 lda	(stmcur),y
	 cmp	lelnm
	 beq	..el3
..el2	rts	
..el3	clc	
	rts	
	endproc


;	Editor get line
;	---------------
egli	proc
	lda	nmfg		; num set?
	beq	egli1		; nope
	 jmp	autonum		; yup

egli1:	jsr	stext		; set cio text
	jmp	io1.s		; do cio + status
	endproc



;	List device open cio for output
;	-------------------------------
opnout:	proc
	lda	#8		; aux1, output
	ldy	#1		; iocb #1
	sty	lstdv
	bne	sc1

;	x reference for output
;	----------------------
fref:	lda	#8		; output
	ldy	#5		; iocb #5
	sty	refdv
	jsr	cio
	jmp	scix

;	input dev open cio for input (hfii is .include entry)
;	-----------------------------------------------------
hfile	inc	cox		; skip # sign
hfi:	ldy	#3		; iocb #3
hfii	lda	#4		; open input
	sty	entdv
	bne	sc1

;	Object dev open for output
;	--------------------------
fobjcx	inc	cox
fobj:	lda	#8		; output
	ldy	#2		; iocb #2
	sty	objdv

;	Do OPEN device
;	--------------
sc1	jsr	cio
	jsr	movespc
scix	jsr	getio
io1.s	jsr	io1
	jmp	getstat
	endproc


;===========================
;	Error Handler
;	-------------
puterrasm: proc
	bit	real		; assembler entry
	bpl	puterr		; only if pass 2
..eh3	 rts			; else, return

puterr:	ldx	#0
	stx	dspflg		; reset display control
	stx	nmfg		; clear auto num
	ldx	eix		; get er stack ptr
	beq	..eh4		; br if first err
	 cpx	#3		; top of stack?
	 bcs	..eh1		; yup

..eh5	cmp	errstack-1,x	; see if error
	beq	..eh1		; type already reported
	 dex	
	 bne	..eh5

	ldx	eix
..eh4	sta	errstack,x	; no, save it
	inc	eix		; bump err index

..eh1	asl	a		; cio error?
	lda	eaf		; if 0, then not asm
	beq	..eh2
	bcc	..eh3		; cc= non-cio err
	jsr	ppass		; title & page strings
	jsr	sppr		; list asm line
..eh2	jsr	listerr
	jmp	noprm		; edit exit
	endproc



;	Memory manager - expand
;	-----------------------
exptxt	proc
	eor	#-1		; compliment
	tay	
	iny	
	ldx	#stmcur
explow:	lda	#0
expand:	sty	mvsiz		; save expand
	sta	mvsiz+1		; size
	sec			; test memtop+1
	lda	memtop
	adc	mvsiz
	tay	
	 lda	memtop+1
	 adc	mvsiz+1
	 cmp	mtp+1		; must be less
	 bcc	..exsf		; than high mem
	 bne	exxi		; oops
	cpy	mtp		; check low
	bcc	..exsf
	beq	..exsf

exxi:	lda	#1		; mem full err
abort:	ldy	#0		; clear junk errs
	sty	eix
	sty	epf		; replace flag
	ldy	eaf		; assembling?
	beq	..ab0		; no
	 pha			; save error
	 jsr	ppage		; dump page string
	 jsr	sppr		; force list of line
	 pla	

..ab0	jsr	puterr		; stack err
	jsr	listerr		; if asm then
	jmp	asmexit		; abort

;	put to buffer/ & mask 7th bit
;	-----------------------------
p20:	lda	#$20
p7f	and	#$7f		; bit off
p58:	ldy	cix		; cur buff index
	sta	(inbuff),y	; store
	inc	cix		; bump index
	beq	..ter		; if overflow
	 rts	
..ter	lda	#22		; list tabbing err
fter:	jmp	abort

..exsf	sec			; form mvlng
	lda	memtop		; move from adress
	sbc	0,x		; mvlng=
	sta	mvlgn		; memtop-exp adress
	 lda	memtop+1	; mvfa(l)= exp
	 sbc	1,x		; adress(l)
	 sta	mvlgn+1		; mvfa(h)= exp

	 clc			; adress(h) + mvlng(h)
	 adc	1,x		; mvfa= !memtop
	 sta	mvfa+1		; set mvfa(h)

	lda	0,x
	sta	mvfa		; set mvfa(l)
	sta	svesa		; save pre-move value
	adc	mvsiz		; mvta(l)= exp
	sta	mvta		; adress(l)+ mvsiz(l)
	 lda	1,x		; mvta(h)= [carry +
	 sta	svesa+1		; exp adress(h)+
	 adc	mvsiz+1		; mvsiz(h)]+
	 adc	mvlgn+1		; mvlng(h). mvta=
	 sta	mvta+1		; memtop+ mvsiz

..ep1	lda	0,x		; add mvsiz to
	adc	mvsiz		; all table entrys
	sta	0,x		; from expand at
	lda	1,x		; adress to high mem
	adc	mvsiz+1
	sta	1,x
	inx	
	inx	
	cpx	#memtop+2	; at limit?
	bcc	..ep1		; no

	ldx	mvlgn+1
	inx			; mvlng(h)+1 in x
	ldy	mvlgn		; mvlng(l) in y
	bne	..ep4		; test 0 length
	beq	..ep5		; br low =0

..ep2	dey			; pop mvlng(l),
	dec	mvfa+1		; mvfa(h), &
	dec	mvta+1		; mvta(h)

..ep3	lda	(mvfa),y	; move 255 bytes
	sta	(mvta),y
..ep4	dey	
	bne	..ep3

	lda	(mvfa),y	; move zero byte
	sta	(mvta),y
..ep5	dex			; another 256 byts?
	bne	..ep2		; yup
	rts			; done!
	endproc


;	Memory manager contract
;	-----------------------
contxt:	proc
	tay	
	ldx	#stmcur
conlow	lda	#0

contract:
	sty	mvsiz		; save contract size
	sta	mvsiz+1		; x
	sec			; form move
	lda	memtop		; lenght low
	sbc	0,x		; mvlng(l)=$100-
	eor	#-1		; memtop(l)-contract
	tay			; adress(l), y = 2's
	iny			; compliment
	sty	mvlgn		; x
	 lda	memtop+1	; set mvlng(h)
	 sbc	1,x
	 sta	mvlgn+1

	lda	0,x		; set mvfa, mvfa =
	sbc	mvlgn		; contract adress-mvlng(l)
	sta	mvfa		; at move mvlng(l)
	 lda	1,x		; will be added to
	 sbc	#0		; mvfa in (ind),y
	 sta	mvfa+1		; instruction
	stx	mvta		; temp save

..cont1	sec			; subtract mvsiz
	lda	0,x		; from table from
	sbc	mvsiz		; contract adress to
	sta	0,x		; high mem
	lda	1,x
	sbc	mvsiz+1
	sta	1,x
	inx	
	inx	
	cpx	#memtop+2	; done?
	bcc	..cont1		; no

	ldx	mvta		; mvta= new contract -
	lda	0,x		; mvlng(l), during
	sbc	mvlgn		; move mvlng(l) will
	sta	mvta		; be added to mvta
	lda	1,x		; in (ind),y instr
	sbc	#0
	sta	mvta+1

cont4	ldx	mvlgn+1		; entry for buffer move
	inx			; mvlng(h) +1 in x
	ldy	mvlgn		; mvlng(l) in y
	bne	..cont3		; test for 0
	dex	
	bne	..cont3
	rts			; nothing to move!

..cont2	inc	mvfa+1		; bump mvfa(h)
	inc	mvta+1		; bump mvta(h)
..cont3	 lda	(mvfa),y	; move 256 bytes
	 sta	(mvta),y
	 iny	
	 bne	..cont3
	dex			; pop high count
	bne	..cont2		; branch if more to do
	rts			; done!
	endproc


;========================================
;	EDITOR UTILITIES PACKAGE
;========================================

$if 0

;	Utilities - change & display mem
;	--------------------------------
dx	proc
	jsr	usa		; set default end
	jsr	getn		; get start addr
	sta	usadr+1
	stx	usadr

	jsr	usa		; set end adr

	jsr	gtokel		; user end address?
	beq	..loop		; nope!
	 jsr	getn		; get end address
	 sta	ueadr+1
	 stx	ueadr

..loop	jsr	docr		; do cr
	lda	usadr		; print out adr
	ldy	usadr+1		; x
	jsr	hxws		; x
	lda	#7		; eight bytes/line
	sta	temp

..udx	ldy	#0
	lda	(usadr),y
	jsr	hxbs		; print byte + sp
	jsr	testbk		; break?
	bne	..uex		; yes
	 jsr	uip		; point to nxt
	 lda	usadr+1		; tst for end
	 ldy	usadr
	 cmp	ueadr+1		; at end?
	 bcc	..unl
	 bne	..uex
	cpy	ueadr		; tst low
	bcc	..unl
	beq	..unl		; yup
..uex	 rts

..unl	dec	temp		; do new line?
	bpl	..udx		; no
	bmi	..loop		; yup!
	endproc


;	Set end address
;	---------------
usa	proc
	clc			; set up
	lda	usadr		; display
	adc	#7		; end adr
	sta	ueadr
	 lda	usadr+1		; high
	 adc	#0
	 sta	ueadr+1
	rts
	endproc
$endif


$if 0

;	Utilities - Execute change
;	--------------------------
cx	proc
	jsr	getn		; starting address
	sta	usadr+1
	stx	usadr
	inc	cox		; past <

..loop	jsr	testbk		; break?
	bne	uip		; yup
	jsr 	gtokel		; done all locations?
	beq	uip		; yup

	cmp	#@lcma		; skip adr?
	bne	..uca		; no
	 jsr	uip		; go point to nxt
	 jmp	..loop		; and loop

..uca	jsr	getne		; get num
	tay			; high should be 0
	bne	..val		; oops >255
	 txa			; low byte to a
	 sta	(usadr),y
	 jmp	..loop		; yup

..val	lda	#10		; val err
	jmp	puterr		; quit & tell user
	endproc


;	Increment pointer
;	-----------------
uip	proc
	inc	usadr		; inc pointer
	bne	..uiy
	 inc	usadr+1
..uiy	rts
	endproc

$endif



;	print line pointed to by stmcur
;	-------------------------------
prli	proc
	jsr	movin		; move to inbuff
				;   fall thru inbout

;	move data pointed to by inbuff
;	------------------------------
inbout:	ldy	#0		; clear index
inbout1:
	sty	cix

..inb	lda	(inbuff),y	; get char
	pha	
	cmp	#linefeed	; line feed?
	bne	..wilk		; nope
	ldy	eaf		; assembling?
	beq	..wilk		; nope
	 jsr	tstej		; test page eject
	 pla	
	 pha			; restore a

..wilk	jsr	charo		; print it
	pla	
	inc	cix		; bump index
	ldy	cix
	cmp	#eol		; if eol, then end
	bne	..inb
	rts	
	endproc


;	Move string to lbuff with eol
;	-----------------------------
movespc	proc
	sta	temp		; spec len in a
	ldx	#0		; clear index
..msp	jsr	gtoke		; get char
	sta	lbuff,x		; put in lbuff
	inx	
	dec	temp		; pop count
	bne	..msp		; loop if more

	lda	#eol		; tack on eol
	sta	lbuff,x
	rts	
	endproc


;	get command token, cmp with @eol
;	--------------------------------
gtokel:	proc
	jsr	gtoke		; get code
	cmp	#@eol		; set status
	rts	
	endproc


;	get a token from exbuff
;	----------------------
gtoke:	proc
	ldy	cox		; get index
	inc	cox		; point to nxt
	lda	(exbuf),y	; get token
	rts	
	endproc


;	Do block I/O
;	------------
; in:
;	a	= command
;	x	= device

blkio	proc
	ldx	objdv		; iocb #
blkio2	lda	#$0b		; put bytes

blkio1	jsr	glcx		; set command & index
	lda	slsz		; move file size
	sta	icbufl,x	; to cio
	lda	slsz+1
	sta	icbufl+1,x
	rts	
	endproc


;	test left margin  (return beq always)
;	-------------------------------------
leftmr:	proc
	lda	leftmar		; left margin?
	bne	space		; do 'em
	 rts	

;	do spaces
;	---------
space3:	lda	#3		; do 3 spaces
space:	sta	ttix
..sc	jsr	dosp
	dec	ttix
	bne	..sc		; return 0
	rts	
	endproc


;	get 1 byte from dev in acc
;	--------------------------
gobj:	proc
	lda	#7		; was 6
	jsr	glcxent		; dev index & cmd
	jsr	io2		; get 1 byte in a
	bmi	..cr3		; err!
	 ldx	#-1		; clear poss zero flg
	 rts	
				; single character out routine
				;  also tests control-1 key (atari)
				;  and re-trys timeout errors
charo:	ldx	lstdv
	inc	column		; bump col cnt

cr1	pha			; save char
	jsr	gcx		; get cio index
	stx	ktmp		; in case fail
	pla			; pop char
..cr2	ldx	ssflag		; start/stop?
	bne	..cr2		; yup wait

	pha			; if error
	tay	
	ldx	ktmp
	jsr	pdum
	pla			; balance stack
	cpy	#138		; did timeout occur?
	bcc	..cr3		; nope
	cpy	#139+1		; or nak
	bcs	..cr3
	 dec	ssflag		; self-inhibit!
	 bcc	..cr2		; unc, go wait

..cr3	tya	
	jmp	gst1		; ck status
	endproc


;	put: y enters char
;	------------------
pdum	proc
	lda	icaux1,x	; set z-page iocb
	sta	icax1z
	lda	icaux2,x
	sta	icax2z
	lda	icput+1,x	; rts to routine
	pha	
	lda	icput,x
	pha	
	tya	
	ldy	#146		; preset not impli
	rts	
	endproc



;	out 2 bytes to dev in A & X
;	---------------------------
outff:	proc
	lda	#-1		; out $ffff
outax	tax	
out2	pha	
	txa	
	jsr	..out1
	pla	
				; out 1 byte to dev in a
..out1	ldx	objdv
	jmp	cr1
	endproc




;	set CIO for input text
;	----------------------
stext:	proc
	lda	#5

				; set dev index & cmd in cio
glcxent	ldx	entdv
glcx	sta	ciocmd		; cmd in a
gcx	stx	ionum		; iocb in x

				; get cio index
getio	lda	ionum
	asl	a
	asl	a
	asl	a
	asl	a
	tax	
	rts	
	endproc


;	Do CIO
;	------
cio:	proc
	pha			; save cio cmd
	sty	ionum		; save iocb #
	jsr	getio
	lda	#$0c		; close dev first
	jsr	io8
	ldy	#3		; cmd for open
	sty	ciocmd
	pla			; get open aux1
	sta	icaux1,x
gtoke7:	jsr	gtoke
	and	#$7f
	rts			; ret a=filspc len
	endproc


;	call 'io4' & fall to 'getstat'
;	------------------------------
io4.s:	proc
	jsr	io4
				; get cio status
getstat:
	jsr	getio		; get dev index
	lda	icsta,x
gst1	bmi	badst
..so6	rts			; ret to caller

badst	ldy	#0		; reset display
	sty	dspflg		; control
	sta	sverr		; save err #
	cmp	#$80		; break?
	bne	so1		; nope
	sty	brkkey		; simulate break
	jsr	cfile		; close files, and
	lda	eaf		; assembling?
	bne	..abr		; yup
	jmp	tef

..abr	sta	bank2		; ^^^^^^^^^ bank 2 ^^^^^^^^
	jmp	asmexit		; abort everything

so1	lda	ionum		; was it enter
	cmp	entdv		; dev?
	beq	so3		; yup
	bne	so4

so2	sta	sverr		; save err
	jsr	reset		; reset for edit

so3	lda	eaf		; ck mode
	bne	so7		; br if in asm
	jsr	cfile		; close
	bne	..so5		; br if not eof

	ldy	eaf		; if not edit,
	bne	..xit		; br
	lda	#0		; clear auto flag
	sta	nmfg		; x
	jmp	prmpt		; ret to edit

so4	jsr	cfile		; close
	beq	..xit		; don't print if eof

..so5	jsr	puterr	; CART does it this way!!
..xit	rts		; everyone else branched to ..so6 in steves version!

so7	lda	sverr
	cmp	#eof		; eof?
	bne	so4		; no, print error

	ldx	ionum
	cpx	#4		; we in .include?
	beq	so8		; yup
	lda	eaf		; don't point after
	bpl	..xit		; 2nd pass; return

	lda	#$25
	jsr	glcxent		; dev index & cmd

	lda	#2		; second byte
	sta	icbyt,x
	lda	pointer		; move sector #
	sta	icsec,x		; to iocb
	lda	pointer+1
	sta	icsec+1,x
	jsr	io5		; go do it
	bmi	so2		; if err
	jmp	popsizef	; get file size

so8	jsr	close		; close include dev
	lda	oldentdv	; restore old
	sta	entdv		; dev, and close
	sta	ionum		; restore ionum!!!
	beq	so9		; skip if memory file

	ldy	#5		; restore buffer
	jsr	movedv
	ldx	#5		; restore pointers
so0	lda	savdevi,x
	sta	buffer,x
	dex	
	bpl	so0

so9	lda	#$40		; set eof for
	sta	eofflag		; include
	rts	
	endproc



;	close routines
;	--------------
cfile	proc
	lda	#0		; clear:
	sta	entdv		; enter dev
	sta	lstdv		; list dev
	sta	refdv		; x-ref dev
	sta	objdv		; object dev
	jsr	clsall		; close devices
tef	lda	sverr
	cmp	#eof		; set eof status
	rts	
	endproc

;	close iocb in ionum
;	-------------------
closei:	proc
	sta	ionum
close	jsr	getio
	beq	..zno
	 lda	#$0c
	 jsr	io8
..zno	rts	
	endproc


;	asm - close all devices
;	-----------------------
clsall:	proc
	ldy	#5
	sty	ionum
..cla0	jsr	close
	dec	ionum
	bne	..cla0
	rts	



;	i/o call routine
;	----------------
io1	proc
	ldy	#126		; buf size =126
	 db $2C
io2	ldy	#0		; buf=0 (byte in a)
io3:	lda	#0
	sta	icbufl+1,x	; set buff size
	tya	
	sta	icbufl,x
	lda	inbuff+1
	ldy	inbuff
io4	sta	icbufa+1,x	; set buff adr
	tya	
	sta	icbufa,x
io5	lda	ciocmd		; get cmd
io8	sta	iccom,x		; x
	lda	#0		; clear aux2
	sta	icaux2,x
	jmp	(xcii)		; do i/o
	endproc


;	test for break key or "break"
;	-----------------------------
testbk:	proc
	ldy	#0
	lda	brkkey
	bne	..01
	 dey	
	 sty	brkkey
..01	tya	
	rts	
	endproc


;	print dec # right justified (field size in y)
;	---------------------------------------------
pdnumf	proc
	sta	fr0+1
	stx	fr0
	dey			; pop for cmp
	sty	ttix
	jsr	inii		; integer to ascii
	ldy	#-1		; get digit cnt
..dcl	iny	
	lda	(inbuff),y
	bpl	..dcl
	lda	ttix		; get spaces to
	sty	ttix		; print left of
	sec			; number
	sbc	ttix
	beq	..pn0		; no spaces
	bmi	..pn0		; no spaces
	jsr	space		; leading spaces
	beq	..pn0		; unc, do number

				; print dec num in fr0
pdnum0:	lda	#0		; set high =0
pdnum:	sta	fr0+1
	stx	fr0
prdn:	jsr	inii		; interger to ascii
..pn0	ldx	#-1
	stx	svn2		; init index

..pn1	inc	svn2
	ldy	svn2
	lda	(inbuff),y

enters:	php			; save stat
	bit	entdv		; if entering
	bmi	..pn2		; and in auto, skip
	 jsr	domk		; out char
..pn2	plp	
	bpl	..pn1		; br if not end
	rts	
	endproc


inii:	proc
	jsr	ifp
	jmp	fascc
	endproc


;	print hex word & byte
;	---------------------
hexw:	proc
	pha			; hex word in a & y
	tya			; high in y
	jsr	hexb
	pla	
hexb	pha			; hex byte on a
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	jsr	heo
	pla	
	and	#$0f

heo	tay	
	lda	hext,y
	jmp	charo
	endproc

hext:	db	'0123456789ABCDEF'


;	misc print routines
;	-------------------
hxbs	proc
	jsr	hexb		; hex byte+space
dosp:	lda	#$20		; do space
domk	and	#$7f		; mask 7th bit
..och	jmp	charo

ptsc:	ldy	#high mes	; for start-up msg
ptse:	jsr	ptst		; text str+eol
docr:	lda	#eol		; do eol
	bne	..och
hxws	jsr	hexw		; hex word+space
	jmp	dosp
	endproc


;	do 3 carrage returns
;	--------------------
dcr3	proc
	jsr	docr
	jsr	docr
	jmp	docr
	endproc

;	pr text str pointed by x & y
;	----------------------------
ptst:	proc
	stx	msgadr		; text string
	sty	msgadr+1
	ldy	#-1		; set index
	sty	temp
..54	inc	temp
	ldy	temp
	lda	(msgadr),y
	bmi	domk		; end, return thru
	jsr	domk		; else, jsr
	jmp	..54		; and cont
	endproc


;==========================================
;	Assembler output test routines
;==========================================

;	test to see if we list
;	----------------------
tstlst:	proc
	lda	eaf		; get pass #
	bmi	..qx		; no
	lda	optflag		; opt flg for lst
	bpl	..qz		; yes

tstlss:	and	#$20		; err bit set?
	bne	..qx		; no
	ldx	eix		; err indx
	beq	..qy		; no errs, no lst
..qz	lda	#0
..qx	rts	
..qy	dex			; set not zero
	rts	
	endproc


;	test to see if errors
;	---------------------
tsterr:	proc
	lda	optflag
	and	#$20		; err bit set?
	bne	..qv		; no
	 jmp	listerr		; list errors

..qv	lda	#0		; clr er indx
	sta	eix
	rts	
	endproc


;	test for page eject
;	-------------------
tstejcr: proc
	jsr	docr		; do a cr first
tstej:	inc	linecnt		; inc line cnt
	lda	linecnt
	cmp	formsz		; at max?
	bcc	tstj1		; no
				; non-centronics entry
ject	lda	optflag
	lsr	a		; no eject opt?
	bcs	tstj0		; yes

;	eject page
;	----------
	jsr	tstlst
	bne	tstj0		; ret

ppass:	lda	fr0		; stack fr0
	pha	
	lda	fr0+1
	pha	
	lda	topfc		; centronics if 0
	beq	..ctr0
	 jsr	charo		; do top of form
	 jmp	..ctr1

..ctr0	jsr	dcr3
..ctr1	jsr	ptitle
	jsr	ppage
	jsr	dcr3
	pla			; unstack fr0
	sta	fr0+1
	pla	
	sta	fr0
tstj0	lda	#0		; clr pg cnt
	sta	linecnt		; stat = 0
tstj1	rts	
	endproc


;	Directive - .PAGE
;	-----------------
@@page:	proc
	ldx	#1		; get string statement
	jsr	msrg		; move string
	jsr	tstlst		; see if list
	bne	@ph		; no list
	 jsr	spp3		; list line
				;   bit linecnt just ejected?
				;   branch @ph
	 jsr	page55		; eject nxt page
	 dec	linecnt		; reset to -1
@ph	rts			; else, ret
	endproc


;	do blank lines until new page
;	-----------------------------
page55	proc
	lda	topfc		; centronics if 0
	beq	page56
	jmp	ject		; and page eject

@pk	jsr	docr
page56	jsr	tstej		; bump line cnt
	lda	linecnt		; test for zero
	bne	@pk		; do blank line
	rts	
	endproc


;	Print .TITLE & .PAGE
;	--------------------
ptitle	proc
	lda	refdv		; doing x-refs?
	bne	..nwr		; no
	 lda	sxref		; option no x-ref?
	 beq	..nyr		; no
..nwr	lda	#rfpag		; flag page
	jsr	xrout

..nyr	jsr	leftmr		; test left margin
	inc	pagenum		; bump page count
	bne	..pi0
	 inc	pagenum+1

..pi0	ldy	#high pames	; print 'page  '
	ldx	#low pames
	jsr	ptst

	ldx	pagenum		; print page number
	lda	pagenum+1
	jsr	pdnum		; pr page #
	jsr	space3		; three spaces

	ldx	strings		; print title string
	ldy	strings+1
	jmp	ptse		; print & ret
	endproc


;	print page string & current file
;	--------------------------------
ppage	proc
	lda	#0		; init column
	sta	column
	jsr	leftmr		; test margin
	clc			; form pagep addr
	ldy	strings+1
	lda	strings
	adc	#strmax
	tax			; low in x
	bcc	..ppq
	 iny	
..ppq	jsr	ptst		; print page string
	jsr	dosp		; trail a space
	sec			; get # of fill spaces
	lda	rightmar
	sbc	column
	bcc	..pof		; no fill
	sbc	#fz		; and size of buff
	bcc	..pof		; no fill
	 jsr	space		; do fill

				; now, dump current filespec
..pof	lda	svedv		; get macro saved dev
	ldy	mcrsk		; in a macro?
	bne	..im		; yes, a= dev#
	 lda	entdv		; else, get cur dev

..im	cmp	#4		; include = iocb #4
	ldy	#high asmfm	; set for main
	ldx	#low asmfm
	bcc	..pw		; it's main
	 $if (high asmfm) <> (high asmfi)
	  ldy	#high asmfi
	 $endif
	 ldx	#low asmfi	; else, include file
..pw	jmp	ptse		; pr str & eol
	endproc


pames	x_db	'PAGE '
ssm	x_db	'SYMBOLS'
ssml	equ	$-ssm

errasm:	x_db	'ASSEMBLY ERRORS: '
bytasm:	x_db	' BYTES FREE'
chartype
	db	' ?=?%?=?'



;	Assembler listing & object routine
;	----------------------------------
	proc
..nrg	lda	#19
	jmp	abort

putinbuf0:
	sta	tpobuf		; format cnt
putinbuff:
	bit	eaf		; get pass
	bpl	..pf1		; num 2
..pf2	 jsr	dopc		; update pc
	 sta	asmpc+1
	 stx	asmpc
	 rts	
				; PASS 2: do object & listing
..pf1	bit	optflag		; test for obj
	bvs	..nbj		; nope!
	jsr	gpc		; get offsetted pc
	sta	ztemp4
	sty	ztemp4+1

	lda	objix		; ptr =0?
	beq	..nbj		; yup
	lda	pcdef		; is pc def?
	beq	..nrg		; no, err
	ldy	objdv		; to a dev?
	bne	..pf4		; yup

	dey			; set y to $ff
..pf3	iny	
	cpy	objix		; done?
	bcs	..nbj		; y
	 lda	tpobuf+1,y
	 sta	(ztemp4),y	; put in mem
	 bcc	..pf3		; jump always

..pf4	ldy	#-1		; to device
	sty	svf2		; temp
..pf5	inc	svf2
	ldy	svf2
	cpy	objix		; at end?
	bcs	..nbj
	 lda	tpobuf+1,y	; fill obj
	 jsr	inbuffo		; buffer
	 bne	..pf5		; jump always

				; do listing output
..nbj	lda	#0
	sta	tobjdex
	jsr	tstlst
	bne	..pf2		; no list

	jsr	pobjl		; pr obj l.
	lda	#16		; cal space fill
	sec			; x
	sbc	column		; never zero
	jsr	spcem		; spaces & macro m
	jsr	asmlst		; pr input l.

..al4	lda	objix		; if obj =0 then
	beq	..al3		; end
	 jsr	pobjl		; else, do obj l.
	 jsr	docr		; and eol
	 jmp	..al4		; repeat
..al3	jmp	tsterr		; ret thru
	endproc



;	print line of object
;	--------------------
pobjl	proc
	jsr	tstej		; eject?
	jsr	leftmr		; test left margin
	lda	#0
	sta	column		; init column
	jsr	papc		; print pc w/space
	lda	objix
	beq	..p00		; all done!
	lda	tpobuf		; get format
	sta	zt1

..p01	ldy	tobjdex
	lda	tpobuf+1,y	; get byte
	jsr	hexb		; pr hex
	inc	asmpc		; set for next
	bne	..p02
	 inc	asmpc+1

..p02	inc	tobjdex
	dec	objix
	beq	..p00		; done
	 dec	zt1		; dec bytes on l.
	 bne	..p01
..p00	rts	
	endproc


papc:	proc
	jsr	gpc		; get pc
	jmp	hxws
	endproc


gpc	proc
	clc	
	lda	asmpc
	adc	offset		; add in offset
	tax			; save in x
	lda	asmpc+1
	adc	offset+1
	tay	
	txa	
	rts	
	endproc



;	get token line (faster 12/16/83)
;	--------------------------------
objx3:	proc
	lda	#3		; get 3 bytes (line header)
objx:	sta	many		; save bytes to get
newget	lda	bytcnt+1	; empty buffer?
	bne	..ij0		; can't be!
	ora	bytcnt
	beq	get_1k		; get next block
	cmp	many		; enough in there?
	bcs	..ij0		; yes

			; last line is short...
			;  do as two call to "objx"
	sec	
	lda	many
	sbc	bytcnt		; calculate remainder
	pha			; save that
	lda	bytcnt		; get greatest #
	jsr	objx
	pla	
	bne	objx		; unc, get remainder

			; get specified number of bytes
..ij0	clc			; set-up move to addr
	lda	cox		; so 'many' can be counter
	adc	exbuf
	sta	amvta
	 lda	exbuf+1
	 adc	#0
	 sta	amvta+1

	ldy	#0		; now, the fast move
..ij1	lda	(buffer),y
	sta	(amvta),y
	iny	
	cpy	many
	bcc	..ij1
	pha			; save last byte!!!

			; now, adjust pointers, counters
	lda	bytcnt		; cs, pop byte count
	sbc	many
	sta	bytcnt
	lda	bytcnt+1
	sbc	#0
	sta	bytcnt+1

	clc			; bump buffer ptr
	tya			; y= 'many'
	adc	buffer
	sta	buffer
	bcc	..ij2
	 inc	buffer+1
	 clc	

..ij2	tya			; adjust 'cox'
	adc	cox		; store new cox
	sta	cox
	pla			; recover last byte
				; cc= sucess
	rts			; a=last byte moved

			; get next block from device

get_1k	lda	filesize+1	; test for eof
	ora	filesize
	beq	reof

	ldx	filesize
	lda	filesize+1	; see if get will
	cmp	#high bufsize	; be less than buffer
	bcc	getk2
	 lda	#high (bufsize-1)	; set # of
	 ldx	#low (bufsize-1)	; bytes to get

getk2	sta	slsz+1
	stx	slsz
	sec			; adjust
	lda	filesize	; number of bytes
	sbc	slsz		; remaining for
	sta	filesize	; this file
	 lda	filesize+1
	 sbc	slsz+1
	 sta	filesize+1

	lda	#7		; 'get block' cmd
	ldx	entdv		; input dev
	jsr	blkio1		; set some cio
	lda	buffers+1	; set buffer addr
	sta	buffer+1
	ldy	buffers
	sty	buffer
	jsr	io4		; do cio

	cpy	#$80		; break abort?
	beq	doquit		; yup
	bcc	..tstc		; get byte count
	cpy	#eof		; cio eof?
	beq	..tstc		; yup, ignore

	 jsr	getstat		; handle error
doquit	 jmp	asmexit		; finish up

			; copy number of bytes moved
..tstc	lda	icbufl,x
	sta	bytcnt
	 lda	icbufl+1,x
	 sta	bytcnt+1
	jmp	..ij0		; unc

			; handle eof
reof	lda	entdv		; simulate call to cio
	sta	ionum
	lda	#eof
	jsr	badst		; handle eof
	sec			; set eof status
	rts	
	endproc


;	move device buffers
;	-------------------
; in:
;	y	= move direction

movedv	proc
	ldx	#3
..mvbf	lda	bufftab,y
	sta	mvfa,x
	dey	
	dex	
	bpl	..mvbf

	lda	#low (bufsize ^ -1) + 1
	sta	mvlgn
	 lda	#high bufsize
	 sta	mvlgn+1
	jmp	cont4
	endproc


;	put object buffer to dev
;	------------------------
runout:	proc
	ldy	#0		; pre-set <256
	lda	objptr		; buffer size
	bne	runo0		; br: less
	 iny			; set = 256
runo0	sta	slsz		; set-up for blkio
	sty	slsz+1
	jsr	blkio
	lda	objbuf+1	; buff address
	ldy	objbuf
	jmp	io4.s		; go do it
	endproc


;	Directive - .INCLUDE
;	--------------------
@@include: proc
	inc	cox		; skip pound sign
	lda	entdv
	cmp	#4		; already include?
	beq	inest
	sta	oldentdv	; save iocb

	tay	
	beq	fincl		; don't move if memory
	jsr	movedv		; y = 3
	ldx	#5		; save primary pointers
..incsv	lda	buffer,x
	sta	savdevi,x
	dex	
	bpl	..incsv

fincl	lda	#0		; clear byte count
	sta	bytcnt
	sta	bytcnt+1
	jsr	intlbf		; reset inbuff
	ldy	#4		; iocb #4
	jsr	hfii		; do cio

	ldy	#low asmfi	; CART version...
	jsr	hstr

	jsr	validf		; test ck bytes
	ldx	#high $ff00	; (line #65280)
	stx	lastl+1		; force x-ref word token
	jmp	spp3		; list

inest	lda	#21		; include err
	jmp	sp3er
	endproc


;	move filespec string for listing
;	--------------------------------
; in:
;	Y	= low addr of buffer

hstr:	proc
	$if (( high (asmfi- high asmfi))) <> (( high (asmfm- high asmfm)))
	 $error "asmfi, asmfm page"
	$endif

	ldx	#high asmfi	; CART does it this way!
	stx	srcadr+1
	sty	srcadr
	ldy	#0
..mm	lda	lbuff,y
	sta	(srcadr),y
	iny	
	cmp	#eol		; done?
	beq	..ml		; yup
	cpy	#fz
	bcc	..mm		; no

..ml	dey			; flag last char
	ora	#$80
	sta	(srcadr),y
	rts	
	endproc



;	dump x-ref data
;	---------------
xrout:	proc
	ldx	#0		; byte in a
	sta	(xrefbufi,x)	; store
	inc	xrefbufi	; bump pointer
	bne	..qrfo
	 inc	xrefbufi+1	; bump pointer h

..qrfo	lda	xrefbufi+1
	cmp	asmram+3	; top of buff?
	bcc	..qrfr		; nope
	 lda	xrefbufi	; try low
	 cmp	asmram+2
	 bcs	rfwrite		; dump this block
..qrfr	rts	

rfwrite:
	sec			; form buff size
	lda	xrefbufi
	sbc	bufferx
	tax	
	 lda	xrefbufi+1
	 sbc	bufferx+1
	stx	slsz		; for blkio
	 sta	slsz+1
	txa	
	ora	slsz+1		; nothing there?
	beq	..qrfr		; nope!

	clc	
	txa			; update file size
	adc	xrefsz
	sta	xrefsz
	 lda	slsz+1
	 adc	xrefsz+1
	 sta	xrefsz+1

	tya	
	pha			; save y
	ldx	refdv
	jsr	blkio2		; set-up cio
	lda	bufferx+1
	sta	xrefbufi+1	; reset buffer
	 ldy	bufferx
	 sty	xrefbufi
	jsr	io4.s		; do cio
	pla	
	tay			; restore y
v00	rts	
	endproc



wrtxref: proc
	bit	eaf		; only if pass 2
	bmi	v00
	lda	xrindx		; something there?
	beq	v00		; nope!
	lda	refdv		; and doing it...
	beq	v00

	ldy	#1
	lda	(exbuf),y	; line # relative?
	cmp	lastl+1
	bne	yrfw		; nope
	dey	
	lda	(exbuf),y	; low
	sec	
	sbc	lastl
	beq	yrfb		; if 0
	cmp	#120
	bcs	yrfb		; two byte relative
	eor	#-1		; compliment
	adc	#1
	bne	yrrv

yrfb	pha			; save offset
	lda	#rfnub		; relative >=120
	jsr	xrout
	pla	
yrrv	jsr	xrout		; out it
	jmp	..uref0		; y=0

yrfw	lda	#rfnum		; line # word flag
	jsr	xrout
	ldy	#1
..yxr	lda	(exbuf),y	; hi/lo format
	jsr	xrout
	dey	
	bpl	..yxr
	iny			; y=0

..uref0	lda	xrefbuf,y	; out references
	jsr	xrout
	 lda	xrefbuf+1,y
	 jsr	xrout
	iny	
	iny	
	cpy	xrindx		; done?
	bcc	..uref0

	ldy	#0		; reset index
	sty	xrindx
			; set last line #
	lda	(exbuf),y
	sta	lastl
	 iny	
	 lda	(exbuf),y
	 sta	lastl+1
	rts			; ret
	endproc



;	note starting sector of entdv
;	-----------------------------
donote:	proc
	lda	#$26		; set for note command
	jsr	glcxent
	jsr	io5		; do cio
	lda	icsec,x		; save sector # for
	sta	pointer		; pass 2 or x-ref use
	lda	icsec+1,x
	sta	pointer+1
	jmp	getstat		; ret & check status
	endproc


;======================================================================


;	symbol table print out
;	----------------------
@@symbol: proc
	jsr	asmmess		; asm end message
	lda	#0		; init to no x-ref
	sta	rfpagf
	lda	refdv		; doing x-ref?
	bne	drefs		; yup!
	lda	optflag		; check list option
	bmi	..10
	 jmp	ps1
..10	rts			; no list, no table!

			; dump x-refs
drefs	lda	#($c1*2)&255	; set pre-shifted value
	asl	optflag		; bit 7 to carry (list bit)
	ror	a		; to bit 7 of acc
	lsr	optflag		; clearing bit 7
	sta	rfpagf		; format flag:
			;  a=$41 print page #'s
			;  a=$c1 no page #'s
	lda	#1		; contract macro
	ldy	#0		; parameter stack
	ldx	#stack+2
	jsr	contract
				; contract macro table
	sec	
	lda	macend
	sbc	macstrt
	tay			; low =y
	 lda	macend+1
	 sbc	macstrt+1
	ldx	#macend
	jsr	contract
				;  zap buffers
	lda	#high (bufsize*2+bufsize/2+strmax+(strmax-ssml-1))
	ldy	#low  (bufsize*2+bufsize/2+strmax+(strmax-ssml-1))
	ldx	#asmram+2
	jsr	contract

			; now, test file size
	clc			; can file fit?
	lda	xrefsz
	sta	slsz		; set file size
	adc	memtop
	tax			; save low
	 lda	xrefsz+1
	 sta	slsz+1		; file size high
	 adc	memtop+1
	 cmp	mtp+1
	 bcc	xrok		; good, it'll fit
	 bne	..oops
	cpx	mtp
	bcc	xrok		; good, it'll fit

			; file is too big
..oops	lda	#0
	sta	rfpagf		; no xref's
	beq	ps1
			; burst it in
xrok	ldx	entdv
	lda	#7		; get binary cmd
	jsr	blkio1		; set some cio
	jsr	setbf		; load addr & buffer addr
	jsr	io4.s		; do the io/status

			; dump symbol table
ps1	ldx	#ssml		; move "symbols"
	ldy	#strmax+ssml-1
..00	lda	ssm-1,x		; message
	sta	(strings),y
	 dey	
	 dex	
	 bne	..00

	stx	refdv		; more references
;	stx	sxref		; and shadow		not in CART!

	lda	#$40		; reset asm pass 2
	sta	eaf
	jsr	page55		; eject new page

	sta	bank3		; ^^^^^^^^ bank 3 ^^^^^^^
	jsr	sortsymbols	; sort labels
	sta	bank2		; ^^^^^^^^ bank 2 ^^^^^^^

	ldx	#'@'		; start past locals
	lda	system		; special?
	and	#$20
	beq	..l		; nope
	 dex			; yes, do locals
..l	stx	sindex		; as index

..psn3	lda	sindex		; get index
	inc	sindex		; bump
	cmp	#'Z'+1		; done?
	bcc	..psn1		; no
	 jmp	docr

..psn1	asl	a		; get table index
	tax	
	ldy	spointer-'?'*2+1,x	; high address
	bmi	..psn3		; nothing there.

	jsr	formtop		; set topsort

..ps2	lda	#$80		; just did cr?
	cmp	lablcc
	beq	ps.1		; yes, don't do twice!

	 jsr	tstejcr		; new letter, new line

ps.1	jsr	leftmr		; left margin
	jsr	testbk		; break?
	beq	..ps3		; no
	 rts	

..ps3	lda	#4		; four columns
	sta	lablcc

..ps4	dec	lablcc
	bmi	..ps2		; new line
	bit	lablcc		; special for x-ref
	bvs	ps.1		; yup

	ldx	#6		; start at 6th char
	stx	lablch
				; get offset
	lda	(labelptr-6,x)	; x=6 (fun!)
	sta	lablsz
	tay	
	dey	
	lda	(labelptr),y	; test for macro
	cmp	#eol		; string
	beq	..ps6		; yup, so skip
	cmp	#'('		; or internal local
	beq	..ps6		; yup, so skip
	stx	lablst		; char index (x=6)

	ldy	#3		; get define byte
	lda	(labelptr),y
	and	#7
	tax			; do leading type
	lda	chartype,x	; character
	jsr	charo

	ldy	#1
	lda	(labelptr),y	; print label
	pha			; address
	iny	
	lda	(labelptr),y
	tay	
	pla	
	jsr	hxws		; hex + space

			; out label
..ps5	ldy	lablst		; get index
	inc	lablst
	cpy	lablsz		; past last?
	bcs	pad		; yup, pad spaces
	 lda	(labelptr),y
				; label a local?
	cpy	#6		; only first character
	bne	..nolo
	cmp	#'@'
	bcs	..nolo
	lda	#':'		;local leading char
..nolo
	jsr	domk		; print char
	inc	lablch		; bump char count
	bne	..ps5		; unc

			; pad spaces
pad	jsr	dosp		; space
	inc	lablch		; bump char count
	lda	lablch
	sec			; at next column?
	sbc	#80/4
	beq	..ps7		; yup
	bmi	pad
	sta	lablch
	dec	lablcc		; pop columns
	jmp	pad
			; test last or point to next
			; & handle x-refs
..ps7	lda	rfpagf		; do x-ref?
	beq	..ps6		; nope
	lda	sindex		; get current alpha
	cmp	#'@'		; locals: no references
	beq	..ps6
	 jsr	findr		; find & dump x-refs

..ps6	ldy	#5
	lda	(labelptr),y
	bpl	..ps8		; not last
	 jmp	..psn3		; last, get next

..ps8	jsr	formlab
	sty	labelptr
	sta	labelptr+1
	jmp	..ps4
	endproc



;	dump x-refs
;	-----------
findr	proc
	asl	lablcc		; double columns
	dec	lablcc		; minus 2
	dec	lablcc
	ldx	#0		; init for each pass:
	stx	lastl		; current line #s
	stx	lastl+1
	stx	rfpgn		; page #
	stx	rfpgn+1
	stx	xrfrdo		; no reference flag
	sec	
	lda	labelptr	; form search link
	sbc	smbltp
	sta	link
	 lda	labelptr+1
	 sbc	smbltp+1
	 sta	link+1
	jsr	setbf		; load addr & buffer addr

			; x-ref	search/dump loop
			; ----------------------
..xloop	lda	#$20		; set leading char
	sta	xrfchar
..xlopz	jsr	grefbyt		; byte at a time!
	tax			; find sign
	bmi	..xlo1		; if token type

	cmp	link+1		; a high link
	beq	..xz0		; yes, check low
	 jsr	gref1		; just skip
	 bne	..xloop		; unc

..xz0	jsr	grefbyt		; get low link
	cmp	link		; test
	bne	..xloop		; no match

			; print reference: page #,line #
	bit	lablcc		; fill needed?
	bpl	..nfl		; nope
	 jsr	leftmr		; test margin
	 lda	#20		; for looks
	 jsr	space
	 lda	#4		; set 5 columns
	 sta	lablcc

..nfl	lda	xrfchar		; out leading char
	sta	xrfrdo		; shows referenced
	jsr	charo

	bit	rfpagf		; page #s?
	bmi	..onlyl		; nope
	 lda	rfpgn+1		; print page #
	 ldx	rfpgn
	 ldy	#3		; format size
	 jsr	pdnumf
	 lda	#','		; and comma
	 jsr	charo

..onlyl	ldx	lastl		; print line #
	lda	lastl+1
	jsr	pdnum		; print it
	sec			; format it
	lda	#6
	sbc	svn2
	jsr	space		; two spaces
	dec	lablcc		; pop columns
	bpl	..xloop		; same row

	jsr	tstejcr		; new line
				; high bit indicates
				; space fill needed.
	lda	#$80		; five columns
	sta	lablcc
	bmi	..xloop		; unc

			; handle x-ref tokens
..xlo1	cmp	#rfnum		; single byte offset?
	bcc	..xlo3		; no
	beq	..xlo2
	eor	#-1		; find true difference
	adc	#0		; cs- add 1
..xlo0	clc			; add into lastl
	adc	lastl
	sta	lastl
	bcc	..xlopz		; cont
	 inc	lastl+1
..xlo7	bne	..xlopz		; unc

..xlo4	cmp	#rfpag		; page flag?
	bne	..xlo5		; no
	inc	rfpgn		; just bump & cont
	bne	..xlopz
	 inc	rfpgn+1
	 bne	..xlo7		; unc

..xlo2	jsr	grefbyt
	sta	lastl+1		; hi first
	 jsr	grefbyt
	 sta	lastl
	bne	..xlo7		; unc

..xlo3	cmp	#rfnub		; two byte offset?
	bne	..xlo4
	 jsr	grefbyt
	 bne	..xlo0		; go add

..xlo5	cmp	#rflab		; label flag?
	bne	..xlo6
	lda	#'#'
	sta	xrfchar
	bne	..xlo7		; unc

..xlo6	lda	#0		; must be eof flag
	cmp	xrfrdo		; any references?
	beq	..xlo8		; no, do cr
	 bit	lablcc		; just did cr?
	 bmi	gf_xit		; yup (return)
..xlo8	sta	lablcc		; this forces a cr
	rts	
	endproc


;	get x-ref byte in a, return ne
;	------------------------------
grefbyt	proc
	ldx	#0
	lda	(buffer,x)
gref1	inc	buffer
	bne	gf_xit
	 inc	buffer+1
gf_xit	rts	
	endproc


;	set buffer addr
;	---------------
setbf	proc
	lda	memtop+1	; load addr
	ldy	memtop
	sta	buffer+1	; init buffer addr
	sty	buffer
	rts	
	endproc



;	assembler list entry point
;	--------------------------
asmlst:	proc
asmlst1	ldy	#2		; line length
	lda	(exbuf),y
	ldx	exbuf		; get pointer to
	ldy	exbuf+1		; token line

	sta	bank3		; ^^^^^^^^^ bank 3 ^^^^^^^
	jsr	_edtv		; convert it
	jsr	rightmr		; print to eol & ret
	sta	bank2		; ^^^^^^^^^ bank 2 ^^^^^^^
	rts	
	endproc


;	editor list entry point
;	-----------------------
movin:	proc
	jsr	getoset		; get inter len
	ldx	stmcur		; mv stmcur for
	ldy	stmcur+1	; conversion

edtv	sta	bank3		; ^^^^^^^^^ bank 3 ^^^^^^^
	jsr	_edtv
	sta	bank1		; ^^^^^^^^^ bank 1 ^^^^^^^
	rts	
	endproc


;	dump symbols routines
;	---------------------
formtop: proc
	clc	
	lda	smbltp		; form topsort
	adc	spointer-'?'*2,x	; cc
	sta	labelptr
	tya	
	adc	smbltp+1
	sta	labelptr+1
	rts	
	endproc


;	form from labelptr a enters hi
;	------------------------------
; out:
;	AY	= whatever

formlab: proc
	tax			; save high
	clc	
	dey			; point to low
	lda	smbltp		; add base to
	adc	(labelptr),y	; offset
	tay			; save low
	txa			; do high
	adc	smbltp+1
	rts	
	endproc


;	mac tab	routines & ifs/getslen
;	------------------------------
settab0: proc
	lda	txttab		; pnt to first
	sta	stmcur		; line in memory
	 lda	txttab+1
	 sta	stmcur+1
	lda	#4		; init obj ptr
	sta	objptr

settab:	lda	#8		; set listing
	sta	tab1		; tabs
	lda	#12
	sta	tab2
	lda	#20
	sta	tab3

setztab:
	lda	tab1		; set z-page tabs
	sta	ztab1
	lda	tab2
	sta	ztab2
	rts	
	endproc



;	get string length and increment 'cox' past string
;	-------------------------------------------------
; note:
;	'ifs' is used by .if

getslen: proc
	jsr	gtoke
ifs:	and	#$7f		; this is length
	tay			; save
	clc			; adjust cox
	adc	cox
	sta	cox
	tya			; ret: a =length
	rts	
	endproc


;	put in buffer table entries
;	---------------------------
;	a	= table token index

lookup:	proc
	ldy	#high function
	ldx	#low function	; function
	sec			; subt relative
	sbc	#ch+1		; table offset

lookup1:
	sta	bank1		; ^^^^^^^^^ bank 1 ^^^^^^^ where tables are

	sta	fr0+2		; save table index
	sty	fr0+1		; start of table (h)
	txa			; low of table
	ldx	fr0+2		; entry counter

..loo1	sta	fr0		; table low
	dex			; pointing @ entry?
	bmi	..loo4		; yup, put in buff

	ldy	#-1		; find end of entry
..loo5	iny	
	lda	(fr0),y		; x
	bpl	..loo5		; keep going

	sec			; up-date pointer
	tya			; new ptr = y+1+
	adc	fr0		; old ptr
	bcc	..loo1
	 inc	fr0+1		; bump high
	bcs	..loo1		; unc

..loo4	ldx	fr0+2		; recover token

loo3:	ldy	#0		; clear index
	sta	bank1		; ^^^^^^^^ bank 1 ^^^^^^^^ where tables are
	sty	fr0+2

..loo2	ldy	fr0+2		; move string to
	inc	fr0+2		; holding buffer
	lda	(fr0),y
	pha			; save stat
	jsr	p7f		; store it
	pla	
	bpl	..loo2		; br; not done
	sta	bank3		; ^^^^^^^^^^^ bank 3 ^^^^^^^ to calling bank
	rts	
	endproc


;	put object to buffer
;	--------------------
object:	proc
	ldy	objix
	sta	tpobuf+1,y
	inc	objix
	rts	
	endproc


;	object buffer handler
;	---------------------
; note:
;	fills buffer, then writes

inbuffo	proc
	ldy	objptr
	sta	(objbuf),y
	inc	objptr
	beq	..wrt		; write this buf
	 rts	
..wrt	jmp	write
	endproc
